#INCLUDE "dcdialog.CH"
#INCLUDE "dccursor.CH"
#INCLUDE "directry.CH"
#INCLUDE "appevent.CH"
#INCLUDE "fileio.CH"
#INCLUDE "dll.CH"
#INCLUDE "error.CH"
#INCLUDE "dctree.CH"
#INCLUDE "imclient.CH"

#xtranslate NTrim(<n>)   =>  LTrim(Str(<n>))
#define CRLF  Chr(13)+Chr(10)

#pragma Library("xb2net.lib")
#pragma Library("dclipx.lib")  // eXpress++
#pragma Library("ascom10.lib") // ActiveX
#pragma Library("bap.lib")     // Bap

#define USERID_LEN         50
#define PASSWORD_LEN       20
#define ALIAS_LEN          20

#define SPI_SETFOREGROUNDLOCKTIMEOUT 0x2001
#define SPIF_UPDATEINIFILE    0x0001
#define SPIF_SENDWININICHANGE 0x0002
#define SPIF_SENDCHANGE       SPIF_SENDWININICHANGE

#DEFINE RECORD_TIME_MAX      120

#DEFINE ASFW_ANY      -1

#DEFINE USER_EVENT_GETFILE     1001
#DEFINE USER_EVENT_SETHTML     1002
#DEFINE USER_EVENT_REFRESH     1003
#DEFINE USER_EVENT_VOICECLIP   1004

#DEFINE IM_HOST_NAME              1
#DEFINE IM_HOST_PORT              2
#DEFINE IM_HOST_ALIAS             3
#DEFINE IM_LOCALUSER_ID           4
#DEFINE IM_LOCALUSER_PASSWORD     5
#DEFINE IM_LOCALUSER_ALIAS        6
#DEFINE IM_LOCALUSER_EMAIL        7
#DEFINE IM_LOCALUSER_VISIBLE      8
#DEFINE IM_STARTURL               9
#DEFINE IM_ONLINE_ONLY           10
#DEFINE IM_ALWAYSPROMPT          11

#DEFINE IM_TABPAGE               12
#DEFINE IM_BROWSE                13
#DEFINE IM_CONNECTED             14
#DEFINE IM_MESSAGEWINDOW         15
#DEFINE IM_STATUSMESSAGE         16
#DEFINE IM_CONNECTBUTTON         17
#DEFINE IM_POINTER               18
#DEFINE IM_STATUS                19
#DEFINE IM_TREEROOT              20
#DEFINE IM_GROUPLIST             21
#DEFINE IM_USERGROUPLIST         22
#DEFINE IM_USERLIST              23
#DEFINE IM_USERLISTAVAIL         24
#DEFINE IM_REMOTEUSERS           25

#DEFINE IM_SIZE                  25

#DEFINE USER_ID                   1
#DEFINE USER_LAST                 2
#DEFINE USER_FIRST                3
#DEFINE USER_ALIAS                4
#DEFINE USER_EMAIL                5
#DEFINE USER_STATUS               6
#DEFINE USER_MODE                 7
#DEFINE USER_ONLINE               8
#DEFINE USER_GROUP                9
#DEFINE USER_TAG                 10
#DEFINE USER_NAME                11
#DEFINE USER_CLIENT_VER          12

#DEFINE USER_SIZE                12

#INCLUDE "dcdialog.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "appevent.CH"

STATIC slClientUpdated := .f.
STATIC scClientVersion := '1.0.3'

* -------------

FUNCTION IMClient()

LOCAL aRemoteUsers[0], cLocalUser, cLocalPassword, i, j, cParam, ;
      oIM, cLocalAlias, cRemoteUser, cHost, nPort, aHosts[0], ;
      aRef, aData, lCheckForUpdates := .F., lShowUserWindow, ;
      cBuffer := Space(100), cIniFile, lTaskBar, lTreeView, ;
      cDirectory

***********************************
* Install default error code block
***********************************
ErrorBlock( {|o| IMErrorHandler(o)} )

DC_AutoRestoreWindow( { HKEY_CURRENT_USER, 'Software\Donnay Software\IMClient\Windows' } )

DC_BitmapTransparentColor({192,192,192})

DC_IconDefault(ICON_EXPRESS)

FOR i := 1 TO PCount()
  cParam := PValue(i)
  IF !Empty(cParam)
    IF '/I' $ Upper(cParam)
      cIniFile := Alltrim(Substr(cParam,4))
    ELSEIF '/?' $ Upper(cParam) .OR. '/H' $ Upper(cParam)
      DC_MsgBox({'Command line Options:', ;
                 '', ;
                 '/I:<IniFile> - INITIALIZATION Parameter File', ;
                 '/S: - Run Setup', ;
                 '', ;
                 'Example: IMCLIENT /I:IMROGER.INI' }, ;
                 ,,,,,,,,,,,'8.Courier')
    ELSEIF cParam = '/'
      DC_WinAlert('Unknown command line parameter: ' + cParam)
    ENDIF
  ENDIF
NEXT

IF Empty(cIniFile)
  cIniFile := DC_Path(AppName(.t.)) + 'IMCLIENT.INI'
ENDIF

aRef := {'RunSetup'}
aData := {.f.}

DC_IniLoad( cIniFile, 'IM_MISC', aData, aRef )
IF aData[1]
  IMSetup()
ENDIF

aRef := {'HostName', ;
         'HostPort', ;
         'HostAlias', ;
         'UserID', ;
         'UserPassword', ;
         'UserAlias', ;
         'UserEmail', ;
         'UserVisible', ;
         'StartURL', ;
         'ViewOnlineOnly', ;
         'AlwaysPromptForLogin'}

FOR i := 1 TO 9

   aData := { Space(100), ;
              80, ;
              Space(20), ;
              Space(USERID_LEN), ;
              Space(PASSWORD_LEN), ;
              Space(ALIAS_LEN), ;
              Space(50), ;
              .t., ;
              Space(100), ;
              .f., ;
              .f. }

   DC_IniLoad( cIniFile, 'IM_HOST_' + Alltrim(Str(i)), aData, aRef )

   IF !Empty(aData[1]) .AND. !Empty(aData[2]) .AND. !Empty(aData[3]) .AND. !Empty(aData[4])
     FOR j := 1 TO Len(aData)
       IF j == IM_LOCALUSER_ID
         aData[j] := Upper(Alltrim(aData[j]))
       ENDIF
       IF Valtype(aData[j]) == 'C'
         aData[j] := Alltrim(aData[j])
       ENDIF
     NEXT
     AAdd(aHosts,aData)
   ENDIF

NEXT

IF Empty(aHosts)
  DC_WinAlert('No Host data in ' + cIniFile)
  RETURN .f.
ENDIF

aRef := {'ShowUserWindow', ;
         'TaskBar' }

aData := { .t., ;
           .f. }

DC_IniLoad( cIniFile, 'USER_WINDOW_PREFERENCES', aData, aRef )
lShowUserWindow := aData[1]
lTaskBar := aData[2]

cDirectory := DC_Path(AppName(.t.)) + 'VoiceClips\'
CreateDirectoryA(cDirectory)

cDirectory := DC_Path(AppName(.t.)) + 'Download\'
CreateDirectoryA(cDirectory)

oIM := IM():new( cIniFile, aHosts )
oIM:checkForUpdates := lCheckForUpdates
IF !lTaskBar
  oIM:userBrowse()
  RETURN .f.
ENDIF

TaskBarMenu(oIM,lShowUserWindow)

RETURN slClientUpdated

* ===============

CLASS IM

EXPORTED:

VAR iniFile
VAR lastName
VAR firstName
VAR hosts
VAR remoteUsers
VAR remoteUsersLastName
VAR remoteUsersFirstName
VAR remoteUsersAlias
VAR remoteUsersEmail
VAR connectionStack
VAR host
VAR port
VAR delay
VAR checkForUpdates
VAR progress
VAR messageBox
VAR userBrowseActive
VAR userBrowseGetList
VAR userBrowseWindow
VAR tabPageArray
VAR browseArray
VAR userArray
VAR statusArray
VAR statusMessageArray
VAR connectButtonArray
VAR connectedArray
VAR pointerArray
VAR conversationNumber
VAR enableFileTransfer
VAR enableEmail
VAR messageWindowHotButtons
VAR userWindowHotButtons
VAR sendFileButtons
VAR displayMode
VAR displayStyle
VAR windowToFront
VAR textLanguage
VAR language
VAR treeView
VAR userFont
VAR sendKey
VAR sendKeyString
VAR recordKey
VAR recordKeyString
VAR server
VAR notifyUserLogons
VAR showUserWindow
VAR taskBar
VAR sessionIDs
VAR soapAgents

METHOD Init                        // initialize variables and load INI files
METHOD Start
METHOD Push                        // Push connection info on stack
METHOD Pop                         // Pop connection info from stack
METHOD GetConnection               // Find the window that has the connection
METHOD UserBrowse                  // The main User dialog window
METHOD EditUserPreferences         // Edit user window preferences
METHOD EditMessagePreferences      // Edit message window preferences
METHOD UpdateClientFiles           // Copy newer files from server to client
METHOD UpdateDirectory
METHOD PrivacyOptions              // Not completed
METHOD AddUser                     // Add a new user to the host IMUSER database
METHOD DeleteUser                  // Delete a user from the host IMUSER databse
METHOD setUserStatus               // Set the status of a user
METHOD sendMessageToGroup          // Open IM windows on a list of clients
METHOD sendEmail                   // Send an email
METHOD serverThreadsRunning        // Not used
METHOD waitForMessage              // Wait for a message or change in user status
METHOD messageWindowConference
METHOD sendGroupMessageWindow
METHOD sendTaggedMessageWindow
METHOD refreshBrowses
METHOD setUserFont
METHOD refreshUsers
METHOD hostConnect
METHOD hostDisconnect
METHOD userConnect
METHOD hostConnectStatus
METHOD sendAlertMessage
METHOD showAlertMessage
METHOD getServer
METHOD hotButtonMessage
METHOD tagToggle
METHOD tagUsers
METHOD PickGroups
METHOD GroupList
METHOD toggleViewLoggedOn
METHOD viewLoggedOn
METHOD checkForUpdates
METHOD getLoginInfo
METHOD isOnline
METHOD getPhoto
METHOD setPhoto
METHOD getFile
METHOD putFile
METHOD showNewUser

ENDCLASS

* -----------

METHOD IM:init( cIniFile, aHosts )

LOCAL aRef, aData, lHotButtons := .f., i

::inifile := cIniFile
::connectionStack := {}
::delay := 300
::userBrowseActive := .f.
::hosts := aHosts
::checkForUpdates := .f.
::server := 1
::sessionIDs := {}
::soapAgents := {}

* --------- User Window Preferences ------

aRef := {'LastName', ;
         'FirstName', ;
         'TreeView', ;
         'UserFont', ;
         'ShowUserWindow', ;
         'TaskBar'}

aData := { Pad('<undefined>',30), ;
           Pad('<undefined>',30), ;
           .t., ;
           1, ;
           .t., ;
           .f. }

DC_IniLoad( cIniFile, 'USER_WINDOW_PREFERENCES', aData, aRef )

::lastName := Alltrim(aData[1])
::firstName := Alltrim(aData[2])
::treeView := aData[3]
::userFont := aData[4]
::showUserWindow := aData[5]
::taskBar := aData[6]

* --------- Message Window Preferences ------

aData := { 1, ;
          .t., ;
          .t., ;
          .t., ;
          'EN', ;
          Pad('Enter',20), ;
          Pad('F10',20) }

aRef := {'DisplayMode', ;
         'WindowToFront', ;
         'EnableFileTransfer', ;
         'EnableEmail', ;
         'Language', ;
         'SendKey', ;
         'RecordKey'}

DC_IniLoad(::iniFile,'MESSAGE_WINDOW_PREFERENCES',aData,aRef)

::displayMode := aData[1] // 1-MSN, 2-Yahoo
::windowToFront := aData[2]
::enableFileTransfer := aData[3]
::enableEmail := aData[4]
::textLanguage := aData[5]
::sendKeyString := Alltrim(aData[6])
::recordKeyString := Alltrim(aData[7])

IF Val(::sendKeyString) > 0
  ::sendKey := Val(::sendKeyString)
ELSE
  ::sendKey := KeyString2Num(::sendKeyString)
  IF ::sendKey == 0
    ::sendKey := xbeK_ENTER
    ::sendKeyString := 'ENTER'
  ENDIF
ENDIF

IF Val(::recordKeyString) > 0
  ::recordKey := Val(::recordKeyString)
ELSE
  ::recordKey := KeyString2Num(::recordKeyString)
  IF ::recordKey == 0
    ::recordKey := xbeK_F10
    ::recordKeyString := 'F10'
  ENDIF
ENDIF

* --------- General Preferences ------

aData := {.t.}
aRef := {'NotifyUserLogons'}
DC_IniLoad(::iniFile,'GENERAL_PREFERENCES',aData,aRef)
::notifyUserLogons := aData[1]

* --------- Message Window Hot Buttons ------

aData := Array(12)
AFill(aData,Space(1000))
aRef := {'F1','F2','F3','F4','F5','F6','F7','F8','F9','F10','F11','F12'}
DC_IniLoad(::iniFile,'MESSAGE_WINDOW_HOT_BUTTONS',aData,aRef)
FOR i:= 1 TO Len(aData)
  aData[i] := Alltrim(aData[i])
  IF !Empty(aData[i])
    lHotButtons := .t.
  ENDIF
NEXT
IF lHotButtons
  ::messageWindowHotButtons := aData
ENDIF

* --------- User Window Hot Buttons ------

aData := Array(12)
AFill(aData,Space(1000))
aRef := {'F1','F2','F3','F4','F5','F6','F7','F8','F9','F10','F11','F12'}
DC_IniLoad(::iniFile,'USER_WINDOW_HOT_BUTTONS',aData,aRef)
FOR i:= 1 TO Len(aData)
  aData[i] := Alltrim(aData[i])
  IF !Empty(aData[i])
    lHotButtons := .t.
  ENDIF
NEXT
IF lHotButtons
  ::userWindowhotButtons := aData
ENDIF

* --------- Send File Hot Buttons ------

lHotButtons := .f.
aData := Array(12)
AFill(aData,Space(1000))
aRef := {'S1','S2','S3','S4','S5','S6' }
DC_IniLoad(::iniFile,'SENDFILE_BUTTONS',aData,aRef)
FOR i:= 1 TO Len(aData)
  aData[i] := Alltrim(aData[i])
  IF !Empty(aData[i])
    lHotButtons := .t.
  ENDIF
NEXT
IF lHotButtons
  ::sendFileButtons := aData
ENDIF

RETURN self

* -------------

METHOD IM:ShowNewUser( aUser )

LOCAL GetList[0], GetOptions

@ 2,0 DCSAY aUser[11] FONT '10.Arial Bold' COLOR GRA_CLR_YELLOW
@ 3,0 DCSAY 'has come on line' COLOR GRA_CLR_YELLOW

DCGETOPTIONS COLOR GRA_CLR_DARKCYAN SAYWIDTH 0 ;
   WINDOWROW -300 WINDOWCOL -300 HIDE

DCREAD GUI FIT TIMEOUT 5 ;
   TITLE 'IM Alert' ;
   BUTTONS DCGUI_BUTTON_OK ;
   OPTIONS GetOptions ;
   EVAL {|o|DC_SetWindowTransparency(o:getHwnd(),100), ;
            Sleep(1), ;
            o:show(), ;
            o:setPos({0,-1*o:currentSize()[2]}), ;
            ShowNewUserWindow(o)}

RETURN nil


* -------------

METHOD IM:GroupList()

LOCAL cGroupList, i

IF Empty(::hosts[::server,IM_USERGROUPLIST])
  cGroupList := 'ALL'
ELSE
  cGroupList := ''
  FOR i := 1 TO Len(::hosts[::server,IM_USERGROUPLIST])
    cGroupList += ::hosts[::server,IM_USERGROUPLIST,i] + ;
                  IIF(i<Len(::hosts[::server,IM_USERGROUPLIST]),',','')
  NEXT
ENDIF

RETURN cGroupList

* ------------

STATIC FUNCTION ShowNewUserWindow( oDlg )

LOCAL i, nHeight := oDlg:currentSize()[2], nHandle, nTransparency

nHandle := oDlg:getHwnd()

FOR i := 1 TO nHeight STEP 5
  Sleep(5)
  oDlg:setPos({oDlg:currentPos()[1],oDlg:currentPos()[2]+5})
  nTransparency := Int(100-i)
  IF nTransparency > 0
    DC_SetWindowTransparency(nHandle,nTransparency)
  ENDIF
  oDlg:setSize({oDlg:currentSize()[1]+2,oDlg:currentSize()[2]})
NEXT
DC_SetWindowTransparency(nHandle,0)
RETURN nil

* -------------

METHOD IM:pickGroups()

LOCAL i, lStatus, GetList[0], GetOptions, oBrowse, aTagGroups[0], ;
      nPointer, aGroups

aGroups := ::hosts[::server,IM_GROUPLIST]
aTagGroups := ::hosts[::server,IM_USERGROUPLIST]

@ 0,0 DCPUSHBUTTON CAPTION 'ALL Groups' SIZE 25,1  ;
      ACTION {||aTagGroups := {'ALL'}, ;
                DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 1.5,0 DCSAY 'Use ENTER or DOUBLE-CLICK to tag/untag Groups' SAYSIZE 0

@ 3,0 DCBROWSE oBrowse DATA aGroups SIZE 55,15 FIT ;
      PRESENTATION DC_BrowPres() ;
      POINTER nPointer ;
      FONT '8.Lucida Console' ;
      COLOR {||IIF(aGroups[oBrowse:arrayElement,1] $ aTagGroups, ;
               {nil,GRA_CLR_YELLOW},{nil,GRA_CLR_WHITE})} ;
      ITEMSELECTED ;
         {|n|n:=Ascan(aTagGroups,Trim(aGroups[oBrowse:arrayElement,1])), ;
             IIF(n>0,ARemove(aTagGroups,n),AAdd(aTagGroups,aGroups[oBrowse:arrayElement,1])), ;
             oBrowse:refreshCurrent()}

DCBROWSECOL ELEMENT 1 HEADER 'Name' WIDTH 15 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Description' WIDTH 40 PARENT oBrowse

DCGETOPTIONS NORESIZE

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   NOAUTORESTORE ;
   TO lStatus ;
   TITLE 'Tag Group List' ;
   MODAL ;
   SETAPPWINDOW ;
   OPTIONS GetOptions

IF lStatus
  ::hosts[::server,IM_USERGROUPLIST] := aTagGroups
  DC_GetRefresh(::userBrowseGetList)
ENDIF

RETURN lStatus

* ------------

METHOD IM:start( lUserWindow )

ASize(::connectionStack,0)

::userBrowse(.t.)

RETURN .f.

* ----------

METHOD IM:push( oConnection )

AAdd( ::connectionStack, oConnection )

RETURN nil

* ----------

METHOD IM:pop( oConnection )

LOCAL nFound
nFound := AScan( ::connectionStack, oConnection )
IF nFound > 0
   ARemove( ::connectionStack, nFound )
ENDIF

RETURN nil

* ----------

METHOD IM:getPhoto( nServer, oStatic, oMessageBox, oProgress, oConn )

LOCAL cUserId, cAlias, cLocalFile, aCargo := DC_GetCargo(oStatic), ;
      cPhoto

DEFAULT nServer := ::server

cUserId := aCargo[1]
cAlias := aCargo[2]
cPhoto := cUserID + '.JPG'

cLocalFile := DC_Path(AppName(.t.)) + 'Photos\' + cPhoto

::getFile( nServer, cPhoto,cLocalFile,,,,'Photos',.f.,oMessageBox, oProgress, oConn )

IF !File(cLocalFile)
  DC_WinAlert('Could not get Photo from server.' + Chr(13) + ;
              cAlias + ' did not upload a file.' + Chr(13) + ;
              'Suggest notifying ' + cAlias + ' to upload a Photo File.')
  RETURN .f.
ENDIF

RETURN .t.

* ----------

METHOD IM:setPhoto( nServer, oParent )

LOCAL cLocalFile, GetList[0], GetOptions, lStatus, cDirectory, ;
      aFileFilters, cUserID, cAlias, oMessageBox, oProgress

DEFAULT nServer := ::server

IF oParent:isDerivedFrom('IMConnection')
  cUserID := oParent:localUser
  cAlias := oParent:locarlUserAlias
ELSE
  cUserID := oParent:hosts[nServer,IM_LOCALUSER_ID]
  cAlias := oParent:hosts[nServer,IM_LOCALUSER_ALIAS]
ENDIF

oMessageBox := oParent:messageBox
oProgress := oParent:progress

aFileFilters := { {"JPEG Files", "*.JPG"} }

cLocalFile := Space(100)
@ 0,0 DCSAY 'Photo File (JPG)' ;
      GET cLocalFile POPUP {|c|DC_PopFile(c,,'*.JPG','Choose a Photo',aFileFilters)} ;
      SAYSIZE 0 SAYBOTTOM ;
      GETSIZE 50

DCGETOPTIONS NORESIZE

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TITLE 'Set Photo' ;
   OPTIONS GetOptions ;
   MODAL ;
   SETAPPWINDOW ;
   TO lStatus

IF !lStatus .OR. Empty(cLocalFile)
  RETURN .f.
ENDIF

cDirectory := DC_Path(AppName(.t.)) + 'Photos\'
CreateDirectoryA(cDirectory)

COPY FILE ( Alltrim(cLocalFile) ) TO ( cDirectory + cUserId + '.JPG')

::putFile( nServer, cUserID + '.JPG', cLocalFile,,,'Photos',,,oMessageBox,oProgress)

RETURN .t.

* ----------

METHOD IM:isOnline()

RETURN ::hosts[::server,IM_CONNECTED]

* ----------

METHOD IM:getConnection( cLocalUser, cRemoteUser )

LOCAL oConnection, cRemoteUserID, cLocalUserID, i, j

FOR i := 1 TO Len(::im:connectionStack)
  oConnection := ::im:connectionStack[i]
  FOR j := 1 TO Len(oConnection:remoteUsers)
    cLocalUserID := oConnection:remoteUsers[j]
    cRemoteUserID := oConnection:localUser
    IF Upper(cRemoteUser) == Upper(cLocalUserID) .AND. Upper(cLocalUser) == Upper(cRemoteUserID)
      RETURN oConnection
    ENDIF
  NEXT
NEXT

RETURN nil

* ----------

METHOD IM:sendEMail()

LOCAL i, cEmail := '', aUsers, nPointer

FOR i := 1 TO Len(::hosts)
  IF !::hosts[i,IM_TABPAGE]:minimized
    aUsers := ::hosts[i,IM_BROWSE]:dataSource
    nPointer := ::hosts[i,IM_POINTER]
    IF nPointer > 1 .AND. nPointer <= Len(aUsers)
      cEmail := aUsers[nPointer,USER_EMAIL]
    ENDIF
    EXIT
  ENDIF
NEXT

IF !Empty(cEmail)
  DC_SendMailToDefault( cEmail )
ENDIF

RETURN nil

* ----------

METHOD IM:editMessagePreferences()

LOCAL GetList[0], GetOptions, oGroup1, lStatus, ;
      cStatusMessage, oGroup2, aData[7], aRef, oGroup3, oGroup4

::sendKeyString := Pad(::sendKeyString,20)
::recordKeyString := Pad(::recordKeyString,20)

@ 0,0 DCGROUP oGroup1 CAPTION 'Display' SIZE 40,4

@ 1,2 DCRADIO ::displayMode VALUE 1 PROMPT 'MSN Style' PARENT oGroup1
@ 2,2 DCRADIO ::displayMode VALUE 2 PROMPT 'Yahoo Style' PARENT oGroup1

@ 5,0 DCGROUP oGroup2 CAPTION 'Text Language' SIZE 40,7

@ 1,2 DCRADIO ::textLanguage VALUE 'EN' PROMPT 'English' PARENT oGroup2
@ 2,2 DCRADIO ::textLanguage VALUE 'DE' PROMPT 'German' PARENT oGroup2
@ 3,2 DCRADIO ::textLanguage VALUE 'FR' PROMPT 'French' PARENT oGroup2
@ 4,2 DCRADIO ::textLanguage VALUE 'ES' PROMPT 'Spanish' PARENT oGroup2
@ 5,2 DCRADIO ::textLanguage VALUE 'IT' PROMPT 'Italian' PARENT oGroup2

@ 13,0 DCGROUP oGroup3 CAPTION 'Hot Keys' SIZE 40,4

@ 1,2 DCSAY 'Send Key' GET ::sendKeyString ;
              KEYBLOCK {|n,x,o|o:undo(), ;
                        ::sendKeyString := Pad(Num2KeyString(n),20), ;
                        o:setData()} ;
      GETTOOLTIP 'This is the key use use to send messages (default is ENTER);' + ;
                 'Click here, then Press any key to store new key value' ;
      PARENT oGroup3

@ 2,2 DCSAY 'Record Key' GET ::recordKeyString ;
           KEYBLOCK {|n,x,o|o:undo(), ;
                        ::recordKeyString := Pad(Num2KeyString(n),20), ;
                        o:setData()} ;
      GETTOOLTIP 'This is the key use use to record Voice Clips (default is F10);' + ;
                 'Click here, then Press any key to store new key value' ;
      PARENT oGroup3

@ 18,0 DCGROUP oGroup4 CAPTION 'Misc' SIZE 40,4

@ 1,2 DCCHECKBOX ::enableFileTransfer PROMPT ' File Transfer Button' ;
      PARENT oGroup4 ;
      TOOLTIP 'This will put a button named "Send File" on the message;' + ;
              'window to allow transfer of files'

@ 2,2 DCCHECKBOX ::enableEmail PROMPT ' Email Button' ;
      PARENT oGroup4 ;
      TOOLTIP 'This will put a button named "Send Email" on the message;' + ;
              'window to allow sending of an email'

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   NORESIZE ;
   SAYWIDTH 70 ;
   SAYRIGHTBOTTOM

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TITLE 'Message Window Preferences' ;
   MODAL ;
   OPTIONS GetOptions ;
   SETAPPWINDOW ;
   TO lStatus

IF lStatus

  aRef := {'DisplayMode', ;
           'WindowToFront', ;
           'EnableFileTransfer', ;
           'EnableEmail', ;
           'Language', ;
           'SendKey', ;
           'RecordKey'}

  aData[1] := ::displayMode  // 1-MSN, 2-Yahoo
  aData[2] := ::windowToFront
  aData[3] := ::enableFileTransfer
  aData[4] := ::enableEmail
  aData[5] := ::textLanguage
  aData[6] := ::sendKeyString
  aData[7] := ::recordKeyString

  ::sendKey := KeyString2Num(::sendKeyString)
  ::recordKey := KeyString2Num(::recordKeyString)

  DC_IniSave(::inifile,'MESSAGE_WINDOW_PREFERENCES',aData,aRef)

ENDIF

RETURN self

* ----------

METHOD IM:editUserPreferences()

LOCAL GetList[0], GetOptions, lStatus, aRef, aData[6]

* --------- User Window / General Preferences ------

::lastName := Pad(::lastName,25)
::firstName := Pad(::firstName,25)

@ 0,0 DCSAY 'Last Name' GET ::lastName
@ 1,0 DCSAY 'First Name' GET ::firstName

@ 2,0 DCSAY 'User Font' GET ::userFont PICTURE '9' RANGE 1,3 ;
      TOOLTIP '1/Small, 2/Medium, 3/Large'

@ 4,0 DCCHECKBOX ::treeView PROMPT 'Tree-View style User window' ;
      TOOLTIP 'Uncheck this for a browse-style window of Users'

@ 5,0 DCCHECKBOX ::notifyUserLogons PROMPT 'Notify me when a new user Logs on to server'
@ 6,0 DCCHECKBOX ::showUserWindow PROMPT 'Show user window on startup'
@ 7,0 DCCHECKBOX ::taskBar PROMPT 'Show icon on Taskbar on startup'

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   NORESIZE ;
   SAYWIDTH 90 ;
   SAYRIGHTBOTTOM

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TITLE 'User Window and General Preferences' ;
   MODAL ;
   OPTIONS GetOptions ;
   SETAPPWINDOW ;
   TO lStatus

IF lStatus

  aRef := {'LastName', ;
           'FirstName', ;
           'TreeView', ;
           'UserFont', ;
           'ShowUserWindow', ;
           'TaskBar'}

  aData[1] := ::lastName
  aData[2] := ::firstname
  aData[3] := ::treeView
  aData[4] := ::userFont
  aData[5] := ::showUserWindow
  aData[6] := ::taskBar

  DC_IniSave(::inifile,'USER_WINDOW_PREFERENCES',aData,aRef)

  aRef := {'NotifyUserLogons'}
  aData := Array(1)
  aData[1] := ::notifyUserLogons

  DC_IniSave(::inifile,'GENERAL_PREFERENCES',aData,aRef)

ENDIF

RETURN self


* ----------

METHOD IM:privacyOptions()
RETURN nil


* ----------

METHOD IM:putFile( nServer, cRemoteFile, cLocalFile, cUserName, ;
                   cTempFileName, cLocation, lMakeTempFile, ;
                   cExtension, oMessageBox, oProgress )

LOCAL i,j, oAgent := xbSOAPEnvelope():new(), oResult, aResult, cString, ;
      cResult, cHost, nPort, cText, nHandle, nFileSize, oScrn, ;
      nSegment := 1, nSegmentSize := 100000, cBufferChunk, nBytesInChunk, ;
      nBytesSent := 0, lStatus, cBuffer, cMessage, nStatus, cFileName

DEFAULT lMakeTempFile := .f., ;
        cRemoteFile := '', ;
        cExtension := '.IM'

DEFAULT nServer := ::server

cHost := ::hosts[nServer,IM_HOST_NAME]
nPort := ::hosts[nServer,IM_HOST_PORT]

oAgent:SetVar("FileName", Alltrim(cRemoteFile))  // set the file name on the server
oAgent:SetVar("UserName", cUserName)             // file goes to USERS\<cUserName> on server
oAgent:SetVar("SegmentSize", nSegmentSize)
oAgent:SetVar("Location", cLocation)             // Subdirectory on server (overrides USERS\<cUserName>)
oAgent:SetVar("MakeTempFile",lMakeTempFile)      // Get file name from server as a temp file name
oAgent:SetVar('Extension',cExtension)

oAgent:action := "PutFile"

cLocalFile := Alltrim(cLocalFile)
nHandle := FOpen( cLocalFile )

IF nHandle <= 0
  oMessageBox:setCaption( 'Could not open file: ' + cLocalFile )
  RETURN .F.
ENDIF

nFileSize := FSize(nHandle)
nBytesSent := 0
oAgent:SetVar("Segment",0)
oAgent:SetVar("SegmentSize",0)

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "PutFile" )
nStatus := oResult:GetVar('Status')
cMessage := oResult:GetVar('Message')
cFileName := oResult:getVar('FileName') // get the full path of the file name assigned by the server
                                        // need this when writing out segments

cTempFileName := DC_Path(cFileName,.t.)

oMessageBox:setCaption('Sending: ' + cLocalFile)

IF valtype(nStatus) # "N" .OR. nStatus # 0
  IF valtype(nStatus) # "N"
    oMessageBox:setCaption("(101) Soap Server not responding")
  ELSE
    oMessageBox:setCaption(Alltrim(Str(nStatus)) + ';;' + cMessage )
  ENDIF
  FClose(nHandle)
  RETURN .F.
ENDIF

oAgent:SetVar("SegmentSize", nSegmentSize)
oAgent:setVar("FileSize", nFileSize )
oAgent:setVar("Location",cLocation)
oAgent:setVar("MakeTempFile",.f.)
oAgent:SetVar("FileName", cFileName)

lStatus := .T.
cBuffer := Space(nSegmentSize)

oAgent:KeepAlive(.t.)
nSegment := 1
DO WHILE nFileSize > 0

  FSeek( nHandle, nSegmentSize*(nSegment-1) )
  nBytesInChunk := Fread( nHandle, @cBuffer, nSegmentSize )

  oAgent:setVar( "BufferChunk", cBuffer )
  oAgent:setVar( "BytesInChunk", nBytesInChunk )
  oAgent:SetVar("Segment",nSegment)

  oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "PutFile" )
  nStatus := oResult:GetVar('Status')
  cMessage := oResult:GetVar('Message')
  nBytesSent += nBytesInChunk

  DC_GetProgress( oProgress, nBytesSent, nFileSize )

  IF Empty(oResult)
    oMessageBox:setCaption('(101) Could not connect to Server')
    lStatus := .F.
    EXIT
  ENDIF

  IF nStatus # 0
    oMessageBox:setCaption(Alltrim(Str(nStatus)) + ';;' + cMessage )
    lStatus := .F.
    EXIT
  ENDIF

  IF nBytesInChunk <= 0 .OR. nBytesSent >= nFileSize
    EXIT
  ENDIF

  nSegment++

ENDDO

oAgent:destroy()
FClose(nHandle)
DC_GetProgress( oProgress, 0, 100 )
oMessageBox:setCaption('File: ' + cLocalFile + ' sent!!')

RETURN lStatus

* ----------

METHOD IM:getFile( nServer, cRemoteFile, cLocalFile, cRemoteTempFile, ;
                   lDelete, oAgent, cLocation, lVerbose, oMessageBox, ;
                   oProgress, oConn )

LOCAL i, j, lNewAgent := .F., oResult, aResult, cString, ;
      cResult, cHost, nPort, cText, nHandle, oScrn, cMessage, ;
      nSegment := 1, nSegmentSize := 100000, cBufferChunk, nBytesInChunk, ;
      nBytesReceived, lOverWrite := .t., nLocalFileSize, nRemoteFileSize, ;
      lCompress := .f., cOutBuffer, nOutLen, nStatus, dRemoteFileDate, ;
      cRemoteFileTime, cLocalUser

DEFAULT nServer := ::server

IF Valtype(oAgent) # 'O'
  oAgent := xbSOAPEnvelope():new()
  lNewAgent := .t.
ENDIF

DEFAULT lDelete := .F., ;
        lVerbose := .t.

cLocalFile := Alltrim(cLocalFile)
nBytesReceived := 0

IF !Empty(cRemoteTempFile)
  oAgent:SetVar("FileName", cRemoteTempFile)
ELSEIF !Empty(cRemoteFile)
  oAgent:SetVar("FileName", cRemoteFile)
ENDIF

cHost := ::hosts[nServer,IM_HOST_NAME]
nPort := ::hosts[nServer,IM_HOST_PORT]
cLocalUser := ::hosts[nServer,IM_LOCALUSER_ID]

oAgent:SetVar("Location", cLocation)
oAgent:SetVar("UserName", cLocalUser)
oAgent:SetVar("SegmentSize", nSegmentSize)
oAgent:SetVar("Segment",0)
oAgent:SetVar("SegmentSize",0)
oAgent:SetVar("DeleteFile",lDelete)
oAgent:action := "GetFile"
oAgent:keepAlive(.t.)
oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "GetFile" )
nRemoteFileSize := oResult:GetVar('FileSize')
dRemoteFileDate := oResult:GetVar('FileDate')
cRemoteFileTime := oResult:GetVar('FileTime')

IF valtype(nRemoteFileSize) # "N" .OR. nRemoteFileSize <= 0
  IF valtype(nRemoteFileSize) # "N"
    IF Valtype(oMessageBox) == 'O'
      oMessageBox:setCaption("(101) IM Server not responding")
    ENDIF
  ELSE
    IF Valtype(oMessageBox) == 'O'
      oMessageBox:setCaption('(102) Server file not found: ' + Alltrim(cRemoteFile))
    ENDIF
  ENDIF
  FClose(nHandle)
  RETURN .F.
ENDIF

oAgent:SetVar("SegmentSize", nSegmentSize)

oAgent:SetVar("Compress",lCompress)

nHandle := 0
IF !lOverWrite
  nHandle := FOpen( cLocalFile, FO_READWRITE )
ENDIF

IF nHandle <= 0
  nHandle := FCreate( cLocalFile, FC_NORMAL )
ENDIF

FSeek( nHandle, 0, FS_END )

IF nHandle <= 0
  IF Valtype(oMessageBox) == 'O'
    oMessageBox:setCaption( 'Could not create file: ' + cLocalFile )
  ENDIF
  RETURN .F.
ENDIF

IF Valtype(oMessageBox) == 'O'
  oMessageBox:setCaption('Receiving: ' + cLocalFile)
ENDIF

IF Valtype(oProgress) == 'O'
  DC_GetProgress( oProgress, 0, 100 )
ENDIF

nLocalFileSize := FSize( nHandle )

DO WHILE nRemoteFileSize > 0

  IF Valtype(oProgress) == 'O'
    DC_GetProgress( oProgress, nLocalFileSize, nRemoteFileSize )
  ENDIF

  oAgent:SetVar("StartByte",nLocalFileSize)

  oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "GetFile" )

  IF Empty(oResult)
    IF Valtype(oMessageBox) == 'O'
      oMessageBox:setCaption('Could not connect to Server')
    ENDIF
    EXIT
  ENDIF

  cBufferChunk := oResult:GetVar('BufferChunk')
  nBytesInChunk := oResult:GetVar('BytesInChunk')
  lCompress := oResult:GetVar("Compressed")
  DEFAULT lCompress := .f.

  IF nBytesInChunk > 0

    IF lCompress
      cOutBuffer := Space(nSegmentSize)
      nOutLen := Len(cOutBuffer)
      nStatus := UnCompress( @cOutBuffer, @nOutLen, @cBufferChunk, nBytesInChunk )
      IF nStatus == 0
        cBufferChunk := cOutBuffer
        nBytesInChunk := nOutLen
      ENDIF
    ENDIF

    FWrite( nHandle, cBufferChunk, nBytesInChunk )

    nLocalFileSize := FSize( nHandle )

  ELSE

    EXIT

  ENDIF

  IF nLocalFileSize >= nRemoteFileSize
    EXIT
  ENDIF

ENDDO

FClose(nHandle)

IF !IsFunction('SetFDati') // From Xbase Tools
  DllLoad(DC_Path(AppName(.t.)) + '..\runtime\XbtBase1.dll')
ENDIF
IF IsFunction('SetFDati') // From Xbase Tools
  PRIVATE _cLocalFile := cLocalFile
  PRIVATE _dRemoteFileDate := dRemoteFileDate
  PRIVATE _cRemoteFileTime := cRemoteFileTime
  &('SetFDaTi( _cLocalFile, _dRemoteFileDate, _cRemoteFileTime )')
ENDIF

IF Valtype(oProgress) == 'O'
  IF lVerbose
    DC_GetProgress( oProgress, nLocalFileSize, nRemoteFileSize )
  ELSE
    DC_GetProgress( oProgress, 0, nRemoteFileSize )
  ENDIF
ENDIF

IF Valtype(oMessageBox) == 'O'
  oMessageBox:setCaption('File: ' + cLocalFile + ' received!!')
  IF lVerbose .AND. Valtype(oConn) == 'O'
    cMessage := 'File: ' + cRemoteFile + ' was received by ' + cLocalUser
    oConn:sendMessage( , , , , cMessage )
  ENDIF
ENDIF

IF lNewAgent
  oAgent:destroy()
ENDIF

RETURN nil

* -------------

METHOD IM:CheckForUpdates( nServer, aClientRemote, aMediaRemote, aPhotosRemote )

LOCAL lStatus
LOCAL aClientLocal := Directory(DC_Path(AppName(.t.)) + 'imclient\imclient.dll')
LOCAL aMediaLocal := Directory(DC_Path(AppName(.t.)) + 'media\*.*')
LOCAL aPhotosLocal := Directory(DC_Path(AppName(.t.)) + 'photos\*.*')

DEFAULT nServer := ::server

IF !DirCompare(aClientRemote,aClientLocal)
  DCMSGBOX 'There is a new Client program available on the server', ;
           'Do you want to update now?' YESNO TO lStatus
  IF lStatus
    IF ::updateClientFiles(nServer,.t.)
      DCMSGBOX 'Client file(s) have been updated.', ;
               'You must quit and restart the IM client', ;
               'for the new changes to take affect.', ;
               '', ;
               'Do you want to do this now?' YESNO TO lStatus
      IF lStatus
        slClientUpdated := .t.
        BREAK
      ENDIF
    ELSE
      DC_WinAlert('Client update failed.  Please try again later.')
    ENDIF
  ENDIF
ENDIF

IF !DirCompare(aMediaRemote,aMediaLocal)
  DCMSGBOX 'There are a new media files (audibles) available on the server', ;
           'Do you want to update now?' YESNO TO lStatus
  IF lStatus
    IF ::updateClientFiles(nServer,.f.,.t.,.f.)
      DCMSGBOX 'Media files have been updated.'
    ENDIF
  ENDIF
ENDIF

IF !DirCompare(aPhotosRemote,aPhotosLocal)
  DCMSGBOX 'There are a new photo files available on the server', ;
           'Do you want to update now?' YESNO TO lStatus
  IF lStatus
    IF ::updateClientFiles(nServer,.f.,.f.,.t.)
      DCMSGBOX 'Photo files have been updated.'
    ENDIF
  ENDIF
ENDIF

RETURN nil

* ----------

STATIC FUNCTION DirCompare( aRemote, aLocal )

LOCAL i, nFound, lStatus := .t.

IF Empty(aRemote)
  RETURN .t.
ENDIF

FOR i := 1 TO Len(aRemote)
  IF (nFound := AScan( aLocal, {|a|Upper(a[1])=Upper(aRemote[i,1])} )) == 0
    lStatus := .f.
    EXIT
  ELSE
    IF aRemote[i,3] > aLocal[nFound,3] // Date on remote is later
      lStatus := .f.
      EXIT
    ELSEIF aRemote[i,3] == aLocal[nFound,3] .AND. aRemote[i,4] > aLocal[nFound,4] // Time is later
      lStatus := .f.
      EXIT
    ENDIF
  ENDIF
NEXT

RETURN lStatus

* ----------

METHOD IM:updateClientFiles(nServer,lClient,lMedia,lPhotos)

LOCAL oAgent := xbSOAPEnvelope():new(), oResult, cHost, oDlg, ;
      nPort, lClientUpdated := .t., cUserName, cPassword

DEFAULT lClient := .f., ;
        lMedia := .f., ;
        lPhotos := .f., ;
        nServer := ::server

cHost := ::hosts[nServer,IM_HOST_NAME]
nPort := ::hosts[nServer,IM_HOST_PORT]
cUserName := ::hosts[nServer,IM_LOCALUSER_ID]
cPassword := ::hosts[nServer,IM_LOCALUSER_PASSWORD]
oAgent:setVar('UserId',cUserName)
oAgent:setVar('Password',cPassword)
oAgent:keepAlive(.t.)
oAgent:action := 'GetDirectory'
oAgent:setVar('UserName',cUserName)
IF lMedia
  ::updateDirectory( nServer, cUserName, 'Media', oAgent )
ENDIF
IF lPhotos
  ::updateDirectory( nServer, cUserName, 'Photos', oAgent )
ENDIF
IF lClient
  lClientUpdated := ::updateDirectory( nServer, cUserName, 'IMClient', oAgent )
ENDIF

oAgent:destroy()

RETURN lClientUpdated

* ------------

METHOD im:UpdateDirectory( nServer, cUserName, cPath, oAgent )

LOCAL cLocalUser, aRemoteDir, aLocalDir, i, nFound, oResult, ;
      cRemoteFile, nFileCount, nCount, lUpdated := .F., cDirectory, ;
      cLocalFile, cHost, nPort, oGetFileAgent

DEFAULT cUserName := '', ;
        cPath := '', ;
        nServer := ::server

cHost := ::hosts[nServer,IM_HOST_NAME]
nPort := ::hosts[nServer,IM_HOST_PORT]
oAgent:setVar('Path',cPath)

IF !Empty(cUserName)
  ::messageBox:setCaption('Checking ' + cUserName)
ELSEIF !Empty(cPath)
  ::messageBox:setCaption('Checking ' + cPath)
ENDIF

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "GetDirectory" )
aRemoteDir := oResult:getVar('Directory')

IF Valtype(aRemoteDir) = 'A'
  cDirectory := DC_Path(AppName(.t.)) + cPath
  CreateDirectoryA(cDirectory)
  aLocalDir := Directory(cDirectory + '\*.*' )
  oGetFileAgent := xbSOAPEnvelope():new()
  oGetFileAgent:keepAlive(.t.)
  nFileCount := 0
  FOR i := 1 TO Len(aRemoteDir)
    cRemoteFile := aRemoteDir[i,1]
    nFound := AScan(aLocalDir,{|a|a[1]==cRemoteFile})
    IF nFound == 0
      nFileCount++
    ENDIF
  NEXT
  nCount := 0
  FOR i := 1 TO Len(aRemoteDir)
    cRemoteFile := aRemoteDir[i,1]
    nFound := AScan(aLocalDir,{|a|a[1]==cRemoteFile})
    IF nFound == 0 .OR. !(aRemoteDir[i,2] == aLocalDir[nFound,2])  ; // new size
       .OR. aRemoteDir[i,3] > aLocalDir[i,3]  ; // newer date
       .OR. (aRemoteDir[i,3] == aLocalDir[i,3] .AND. ;
             aRemoteDir[i,4] > aLocalDir[i,4]) // newer time
      ::messageBox:setCaption(cRemoteFile)
      cLocalFile := cDirectory + '\' + cRemoteFile
      cRemoteFile := cPath + '\' + cRemoteFile
      ::getFile( nServer, cRemoteFile, cLocalFile, cRemoteFile, .f., oGetFileAgent,,.f., ;
                 ::messageBox, ::progress )
      nCount++
      DC_GetProgress( ::progress, nCount, nFileCount )
      lUpdated := .t.
    ENDIF
  NEXT
ENDIF

RETURN lUpdated

* -----------

METHOD IM:serverThreadsRunning()

LOCAL nServer, lRunning := .f.

FOR nServer := 1 TO Len(::hosts)
  IF ::hosts[nServer,3]
    lRunning := .T.
  ENDIF
NEXT

RETURN lRunning

* ----------

METHOD IM:getLoginInfo()

LOCAL GetList[0], GetOptions, aHost, lStatus, cLocalUserId, ;
      cLocalUserPassword, cLocalUserAlias, lLocalUserVisible, ;
      lOnlineUsersOnly, cHost, nPort

aHost := ::hosts[::server]

lStatus := .t.

IF aHost[IM_ALWAYSPROMPT] .OR. ;
   Empty(aHost[IM_LOCALUSER_ID]) .OR. ;
   Empty(aHost[IM_LOCALUSER_PASSWORD])

  cHost := aHost[IM_HOST_NAME]
  nPort := aHost[IM_HOST_PORT]
  cLocalUserID := Pad(aHost[IM_LOCALUSER_ID],20)
  cLocalUserPassword := Pad(aHost[IM_LOCALUSER_PASSWORD],20)
  cLocalUserAlias := Pad(aHost[IM_LOCALUSER_ALIAS],20)
  lLocalUserVisible := aHost[IM_LOCALUSER_VISIBLE]
  lOnlineUsersOnly := aHost[IM_ONLINE_ONLY]

  @ 0,0 DCSAY 'Host:' SAYSIZE 0
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY cHost + ':' + NTrim(nPort) SAYSIZE 0 ;
     FONT '10.Lucida Console'

  @ 2,0 DCSAY 'User ID' GET cLocalUserID VALID {||DC_ReadEmpty(cLocalUserID)}
  @ 3,0 DCSAY 'Password' GET cLocalUserPassword PASSWORD ;
        VALID {||DC_ReadEmpty(cLocalUserID)} GETID 'PASSWORD' ;
        KEYBLOCK {|n,x,o|IIF(n==xbeK_ENTER, ;
                     (o:getData(), ;
                      DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)), ;
                      nil)}
  @ 4,0 DCSAY 'Alias' GET cLocalUserAlias

  @ 6,0 DCCHECKBOX lLocalUserVisible PROMPT 'Make me Visible to all users'
  @ 7,0 DCCHECKBOX lOnlineUsersOnly PROMPT 'Show only users who are Online'

  DCGETOPTIONS ;
    NORESIZE ;
    SAYWIDTH 50 ;
    SAYRIGHTBOTTOM ;
    TABSTOP ;
    BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

  DCREAD GUI ;
    FIT ;
    ADDBUTTONS ;
    TO lStatus ;
    TITLE 'Login Info' ;
    OPTIONS GetOptions ;
    MODAL ;
    SETAPPWINDOW ;
    ENTEREXIT ;
    SETFOCUS 'PASSWORD'

  IF lStatus
    aHost[IM_LOCALUSER_ID] := Alltrim(cLocalUserID)
    aHost[IM_LOCALUSER_PASSWORD] := Alltrim(cLocalUserPassword)
    aHost[IM_LOCALUSER_ALIAS] := Alltrim(cLocalUserAlias)
    aHost[IM_LOCALUSER_VISIBLE] := lLocalUserVisible
    aHost[IM_ONLINE_ONLY] := lOnlineUsersOnly
  ENDIF

ELSE

//   IMGetUser( @cLocalUserID, @cLocalPassword )

ENDIF

RETURN lStatus

* ----------

METHOD IM:waitForMessage(nServer)

LOCAL oResult, cHost, nPort, cMessage, cFont, nFGColor, nBGColor, ;
      cRemoteUser, cRemoteAlias, cRemoteFile, cRemoteTempFile, ;
      cRemoteEmail, cRemoteLastName, cRemoteFirstName, cWaveFile, ;
      dDateSent, cTimeSent, oConn, nStatus, cLocalFile, i, j, ;
      cHeader, nRetries := 0, ;
      aUserList, nFound, nConversationNum, nPass, aTokens, ;
      cStatusMessage, nSleep, cLocalUserID, cLocalUserPassword, ;
      cLocalUserAlias, lLocalUserVisible, oAgentLogOff, lStatus, ;
      nMessageType, oAgentUsers, lOnlineUsersOnly, aClientRemote, ;
      aMediaRemote, aPhotosRemote, cLocalUserEmail, oAgentAdd, ;
      cNewUser

IF !::getLoginInfo()
  RETURN .F.
ENDIF

DC_PointerWait()

Sleep(100)
cHost := ::hosts[nServer,IM_HOST_NAME]
nPort := ::hosts[nServer,IM_HOST_PORT]

wtf cHost, nPort, nServer

cLocalUserID := ::hosts[nServer,IM_LOCALUSER_ID]
cLocalUserPassword := ::hosts[nServer,IM_LOCALUSER_PASSWORD]
cLocalUserAlias := ::hosts[nServer,IM_LOCALUSER_ALIAS]
cLocalUserEmail := ::hosts[nServer,IM_LOCALUSER_EMAIL]
lLocalUserVisible := ::hosts[nServer,IM_LOCALUSER_VISIBLE]
lOnlineUsersOnly := ::hosts[nServer,IM_ONLINE_ONLY]

::soapAgents[nServer] := xbSOAPEnvelope():new()
::soapAgents[nServer]:action := "LogOn"
::soapAgents[nServer]:keepAlive(.t.)
::soapAgents[nServer]:setVar('UserID',cLocalUserID)
::soapAgents[nServer]:setVar('Alias',cLocalUserAlias)
::soapAgents[nServer]:setVar('Password',cLocalUserPassword)
::soapAgents[nServer]:setVar('OnlineOnly',lOnlineUsersOnly)
::soapAgents[nServer]:setVar('Visible',lLocalUserVisible)
::soapAgents[nServer]:setVar('DisplayMode',::displayMode)
::soapAgents[nServer]:setVar('Language',::textLanguage)
::soapAgents[nServer]:setVar('ClientVersion',scClientVersion)

oResult := ::soapAgents[nServer]:Execute( Trim(cHost) + ":" + NTrim(nPort), "Logon" )

nStatus := oResult:getVar("Status")
IF nStatus == nil
   cStatusMessage := 'Could Not Establish Connection'
   nStatus := 0
ELSE
   cStatusMessage := oResult:getVar('StatusMessage')
ENDIF
::hosts[nServer,IM_STATUSMESSAGE] := ::hostConnectStatus(cStatusMessage)
DC_GetRefresh(::userBrowseGetList)

IF nStatus == 105 // Invalid User ID
  DC_PointerArrow()
  DCMSGBOX cStatusMessage,'', ;
      'Do you want to be added as a new user to this server?' ;
    YESNO TO lStatus
  IF !lStatus
    RETURN .f.
  ENDIF
  oAgentAdd := xbSOAPEnvelope():new()
  oAgentAdd:action := "AddUser"
  oAgentAdd:setVar('UserID',Alltrim(cLocalUserID))
  oAgentAdd:setVar('Password',Alltrim(cLocalUserPassword))
  oAgentAdd:setVar('FirstName',::firstName)
  oAgentAdd:setVar('LastName',::lastName)
  oAgentAdd:setVar('Alias',Alltrim(cLocalUserAlias))
  oAgentAdd:setVar('Email',Alltrim(cLocalUserEmail))
  oAgentAdd:setVar('AuthID','Administrator')
  oAgentAdd:setVar('AuthPassword','SilverOak1999')
  oResult := oAgentAdd:Execute( Trim(cHost) + ":" + NTrim(nPort), "AddUser" )
  nStatus := oResult:getVar('Status')
  cStatusMessage := oResult:getVar('StatusMessage')
  oAgentAdd:destroy()

  IF nStatus # 210 // could not add user
    DCMSGBOX cStatusMessage
    RETURN .f.
  ENDIF
  oResult := ::soapAgents[nServer]:Execute( Trim(cHost) + ":" + NTrim(nPort), "Logon" )
  nStatus := oResult:getVar("Status")
  cStatusMessage := oResult:getVar('StatusMessage')
  ::hosts[nServer,IM_STATUSMESSAGE] := ::hostConnectStatus(cStatusMessage)
  DC_GetRefresh(::userBrowseGetList)
ELSE
  DC_PointerArrow()
  ::sessionIds[nServer] := oResult:getVar('_SID')
ENDIF

::hosts[nServer,IM_STATUS] := nStatus
aUserList := oResult:getVar('UserList')

::hosts[nServer,IM_GROUPLIST] := oResult:getVar('GroupList')

aClientRemote := oResult:getVar('Client')
aMediaRemote := oResult:getVar('Media')
aPhotosRemote := oResult:getVar('Photos')

IF nStatus # 200 // user list enclosed
  RETURN .f.
ENDIF

::CheckForUpdates( nServer, aClientRemote, aMediaRemote, aPhotosRemote )

::hosts[nServer,IM_CONNECTED] := .t.
::refreshUsers(nServer,aUserList,.f.)

DC_GetRefresh(::userBrowseGetList)

DO WHILE nRetries < 10 .AND. ::hosts[nServer,IM_CONNECTED]

  ASize( ::soapAgents[nServer]:varList, 0 )
  ::soapAgents[nServer]:setVar('OnlineOnly',::hosts[nServer,IM_ONLINE_ONLY])
  ::soapAgents[nServer]:action := 'WaitForMessage'
  ::soapAgents[nServer]:setVar('UserId',cLocalUserID)
  ::soapAgents[nServer]:setVar('Password',cLocalUserPassword)
  ::soapAgents[nServer]:setVar('TimeOut',60*100) // 100 minutes

  oResult := ::soapAgents[nServer]:Execute( Trim(cHost) + ":" + NTrim(nPort) + ;
                             '?_SID="' + ::sessionIDs[nServer] + '"', "WaitForMessage" )

  nStatus := oResult:getVar('Status')
  cStatusMessage := oResult:getVar('StatusMessage')
  ::sessionIds[nServer] := DC_XtoC(oResult:getVar("_SID"))

  IF !::hosts[nServer,IM_CONNECTED]

    EXIT

  ELSEIF nStatus == nil

    nRetries++
    nSleep := DC_Random(3)
    Sleep(nSleep*1000)  // Wait 10-30 seconds before trying to connect to the server again
    LOOP

  ELSEIF nStatus == 105 .OR. nStatus == 108
    DC_WinAlert( 'Could not login to Server.' + Chr(13) + ;
                 'Invalid User ID or Password' )

    EXIT

  ELSE // Either got a message or user status has changed

    Sleep(10)
    nRetries := 0

    IF nStatus == 303 .OR. nStatus == 304 // force user logoff or shutdown
      IF nStatus == 303
        ::hosts[nServer,IM_CONNECTED] := .f.
        DC_GetRefresh(::userBrowseGetList)
        Sleep(200)
        EXIT
      ELSE
        QUIT
      ENDIF
    ENDIF

    IF nStatus $ { 211, 206, 210, 200, 205, 201, 301, 302 }// user status updated
      aUserList := oResult:getVar('UserList')
      nStatus := ::refreshUsers(nServer,aUserList,.f.)
      cNewUser := oResult:getVar('NewUser')

      IF ::notifyUserLogons
        IF !Empty(cNewUser)
          nFound := Ascan(aUserList,{|a|a[USER_ID]==cNewUser})
          IF nFound > 0
            Thread():new():start({||::showNewUser(aUserList[nFound])})
          ENDIF
        ENDIF
      ENDIF
      IF nStatus # 200
         Sleep(500)
         nRetries++
      ENDIF
      LOOP
    ENDIF

    nPass := 0
    cMessage := oResult:getVar('Message')

    DO WHILE nStatus == 204 // Get All messages

      IF cMessage == NIL
        ASize( ::soapAgents[nServer]:varList, 0 )
        ::soapAgents[nServer]:action := 'GetMessage'
        ::soapAgents[nServer]:setVar('UserId',cLocalUserID)
        ::soapAgents[nServer]:setVar('Password',cLocalUserPassword)
        oResult := ::soapAgents[nServer]:Execute( Trim(cHost) + ":" + NTrim(nPort) + ;
                                   '?_SID="' + ::sessionIDs[nServer] + '"', "GetMessage" )

        nStatus := oResult:getVar('Status')
        DEFAULT nStatus := 0
      ENDIF

      IF nStatus == 0 .AND. nPass < 5
        Sleep(20)
        nStatus := 204
        nPass++
        LOOP
      ENDIF

      IF nStatus = 204 // message received

        IF Empty(oResult:getVar('MoreMessages'))
          nStatus := 0
        ENDIF
        cMessage :=  oResult:getVar('Message')
        cFont := oResult:getVar('Font')
        nFGColor := oResult:getVar('FGColor')
        nBGColor := oResult:getVar('BGColor')
        cRemoteUser := oResult:getVar('FromUser')
        cRemoteAlias := oResult:getVar('FromAlias')
        cRemoteFile := oResult:getVar('FileName')
        cRemoteTempFile := oResult:getVar('TempFileName')
        cRemoteEmail := oResult:getVar('FromEmail')
        cRemoteFirstName := oResult:getVar('FromFirstName')
        cRemoteLastName := oResult:getVar('FromLastName')
        cWaveFile := oResult:getVar('WaveFile')
        dDateSent := oResult:getVar('DateSent')
        cTimeSent := oResult:getVar('TimeSent')
        nMessageType := oResult:getVar('MessageType')

        IF Valtype(nMessageType) == 'N' .AND. nMessageType == 2 // Alert Message
          IF !Empty(cWaveFile)
            PlayWave(cWaveFile)
          ENDIF
          ::showAlertMessage(cMessage,dDateSent,cTimeSent,cRemoteFirstName, ;
                             cRemoteLastname,cRemoteAlias,cRemoteUser)
          cMessage := nil
          LOOP
        ENDIF

        nConversationNum := oResult:getVar('ConversationNum')
        oConn := ::getConnection( ::hosts[nServer,IM_LOCALUSER_ID], cRemoteUser )
        IF oConn == nil .AND. !cMessage $ {'<<typing>>','<<nudge>>'}
          oConn := IMConnection():new( self, nServer )
          oConn:remoteUsers := { Upper(Alltrim(cRemoteUser)) }
          oConn:remoteUsersLastName := { cRemoteLastName }
          oConn:remoteUsersFirstName := { cRemoteFirstName }
          oConn:remoteUsersAlias := { cRemoteAlias }
          oConn:remoteUsersEmail := { cRemoteEmail }
          Thread():new():start({||oConn:MessageWindow(.f.)})
          DO WHILE oConn:status == 0
            Sleep(50)
          ENDDO
          Sleep(50)
        ENDIF

        Sleep(10)

        IF Valtype(nConversationNum) == 'N' .AND. Valtype(oConn) == 'O'
          oConn:conversationNumber := nConversationNum
        ENDIF

        IF Valtype(oConn) = 'O'
          IF !Empty(cWaveFile)
            PlayWave(cWaveFile)
            IF Upper(cWaveFile) == 'RING.WAV'
              cMessage := 'RING!!!'
            ENDIF
          ENDIF
          IF Left(cMessage,10) == '<<invite>>'
            aTokens := DC_TokenArray(cMessage,',')
            cMessage := '<b>' + aTokens[2] + ' has been invited to the conference.</b>'
            FOR i := 3 TO Len(aTokens)
              IF !(aTokens[i] == oConn:localUser) .AND. !(aTokens[i] $ oConn:remoteUsers)
                oConn:addRemoteUser(aTokens[i])
              ENDIF
            NEXT
          ENDIF

          IF cMessage == '<<typing>>'
            oConn:messageBox:setCaption(cRemoteFirstName + ' ' + cRemoteLastName + ;
                                        ' is typing a message.')
          ELSEIF cMessage == '<<nudge>>'
            oConn:messageBox:setCaption(cRemoteFirstName + ' ' + cRemoteLastName + ;
                                        ' is sending you a Nudge.')
            Nudge(oConn:dialogWindow)

          ELSEIF !Empty(cMessage)

            IF cMessage == '<<voiceclip>>'
              cLocalFile := DC_Path(AppName(.t.)) + 'VoiceClips\' + cWaveFile
              ::getFile( nServer, cWaveFile,cLocalFile,,.t.,,'VoiceClips',.f., ;
                         oConn:messageBox,oConn:progress,oConn)
              PlayWave( cWaveFile,'VoiceClips\' )
              cMessage := cRemoteAlias + ' has sent you a Voice Clip<br>' + ;
              '<a href = http://VoiceClip\' + cWaveFile + ;
              '>Click here to replay</a>'
            ENDIF

            IF oConn:im:displayMode == 1 // MSN
              IF oConn:lastMessageUser == cRemoteUser
                cHeader := '<IM:remote><table width=100%><tr><th align=left>...</th><td align=right>' + ;
                             cTimeSent + '</td></tr></table></IM:remote>'
              ELSE
                cHeader := '<IM:remote><table width=100%><tr><th align=left>' + cRemoteFirstName + ' ' + cRemoteLastName + ;
                   ' says:</th><td align=right>' + cTimeSent + '</td></tr></table></IM:remote>'
              ENDIF
            ELSEIF oConn:im:displayMode == 2 // Yahoo
              cHeader := '<IM:remoteYahoo>' + cRemoteFirstName + ' ' + cRemoteLastName + ;
                         ' : </IM:remoteYahoo>'
            ELSEIF oConn:im:displayMode == 3 // Text Window
              cHeader := cRemoteAlias + ': '
            ENDIF

            IF oConn:im:displayMode == 3 // Text Window

              oConn:conversationText += cHeader + cMessage // + CRLF
              oConn:conversationObject:setData( oConn:conversationText )
              oConn:conversationObject:setFirstChar(Len(oConn:conversationObject:editBuffer()))

            ELSE

              oConn:conversationText += cHeader + cMessage + '<br>'


              PostAppEvent( xbeP_User + USER_EVENT_SETHTML, ;
                            oConn:conversationHeader + ;
                            oConn:conversationText + ;
                            oConn:conversationFooter, nil, oConn:dialogWindow )

            ENDIF

            oConn:lastMessageUser := cRemoteUser

            IF oConn:im:windowToFront
            ENDIF

          ENDIF
        ENDIF

      ENDIF

      Sleep(20) // wait before getting next message
      cMessage := nil

    ENDDO

  ENDIF

ENDDO

::soapAgents[nServer]:destroy()
::soapAgents[nServer] := nil

IF Valtype(oAgentUsers) == 'O'
  oAgentUsers:destroy()
ENDIF

::hosts[nServer,IM_CONNECTED] := .F.

RETURN self

* ----------

METHOD IM:showAlertMessage(cMessage,dDateSent,cTimeSent,cRemoteFirstName, ;
                           cRemoteLastname,cRemoteAlias,cRemoteUser)

LOCAL GetList[0], GetOptions

@ 0,0 DCSAY 'Message From: '
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY Alltrim(cRemoteFirstName) + ' ' + Alltrim(cRemoteLastname) ;
     SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '10.Courier New Bold' ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 1,0 DCSAY 'Message Date: '
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY DtoC(dDateSent) ;
     SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '10.Courier New Bold' ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 2,0 DCSAY 'Message Time: '
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY cTimeSent ;
     SAYSIZE 0 COLOR GRA_CLR_BLUE FONT '10.Courier New Bold' ;
     RESIZE DCGUI_RESIZE_REPOSONLY_Y

@ 4,0 DCMULTILINE cMessage SIZE 50, 10 ;
      FONT '10.Courier New' NOHSCROLL EDITPROTECT {||.t.} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS ;
   SAYWIDTH 150 SAYRIGHTBOTTOM SAYFONT '10.Courier New'

DCREAD GUI ;
   FIT ;
   BUTTONS DCGUI_BUTTON_OK ;
   OPTIONS GetOptions ;
   MODAL ;
   SETAPPWINDOW ;
   TITLE 'Alert Message'

RETURN nil

* ----------

METHOD IM:refreshUsers( nServer, aUserList, lReload )

LOCAL oResult, nStatus, cStatusMessage, i, j, nFound, ;
      lDestroy := .F., aHost, aSaveUsers, cHost, nPort, ;
      oAgentUsers, aRemoteUsers, oOnLine, oOffLine, ;
      oTreeItem, lNewList := .f., cUserGroupList, lGoodGroup

DEFAULT lReLoad := .f., ;
        nServer := ::server

aHost := ::hosts[nServer]
cHost := aHost[IM_HOST_NAME]
nPort := aHost[IM_HOST_PORT]

IF lReLoad  // Get available users from server
  aHost := ::hosts[nServer]
  cHost := aHost[IM_HOST_NAME]
  nPort := aHost[IM_HOST_PORT]
  oAgentUsers := xbSOAPEnvelope():new()
  oAgentUsers:action := "GetUsers"
  oAgentUsers:setVar('UserID',Alltrim(aHost[IM_LOCALUSER_ID]))
  oAgentUsers:setVar('Password',Alltrim(aHost[IM_LOCALUSER_PASSWORD]))
  oAgentUsers:setVar('OnlineOnly',aHost[IM_ONLINE_ONLY])
  oResult := oAgentUsers:Execute( Trim(cHost) + ":" + NTrim(nPort), "GetUsers" )
  nStatus := oResult:getVar('Status')
  cStatusMessage := oResult:getVar('StatusMessage')
  aUserList := oResult:getVar("UserList")
  oAgentUsers:destroy()
  IF Empty(aUserList)
    aUserList := {}
  ENDIF
  lNewList := .t.
ELSEIF Valtype(aUserList) == 'A'
  lNewList := .t.
  nStatus := 200
ELSE
  aUserList := AClone(aHost[IM_USERLISTAVAIL]) // get previously loaded list of available users
  nStatus := 200
ENDIF

IF lNewList // updated list from server
  aSaveUsers := aHost[IM_USERLIST] // Save away current displayed users (to restore tags)
  aHost[IM_USERLIST] := aUserList  // Store available users to new display list
  FOR j := 1 TO Len(aUserList)
    ASize(aUserList[j],USER_SIZE)
    aUserList[j,USER_TAG] := .F.
    aUserList[j,USER_NAME] := aUserList[j,USER_FIRST] + ' ' + aUserList[j,USER_LAST]
    nFound := AScan( aSaveUsers, {|a|a[USER_ID]==aUserList[j,USER_ID]} )
    IF nFound > 0
      aUserList[j,USER_TAG] := aSaveUsers[nFound,USER_TAG] //retag if previously tagged
    ENDIF
  NEXT
  aHost[IM_USERLISTAVAIL] := AClone(aUserList) // save away the new list
ENDIF

IF !Empty(aHost[IM_USERGROUPLIST]) .AND. !aHost[IM_USERGROUPLIST,1]=='ALL' // remove users who are not in specified group(s)
  FOR i := 1 TO Len(aUserList)
    cUserGroupList := ',' + aUserList[i,USER_GROUP]+','
    lGoodGroup := .f.
    FOR j := 1 TO Len(aHost[IM_USERGROUPLIST])
      IF (',' + aHost[IM_USERGROUPLIST,j] + ',' $ cUserGroupList)
        lGoodGroup := .t.
        EXIT
      ENDIF
    NEXT j
    IF !lGoodGroup
      ARemove(aUserList,i)
      i--
    ENDIF
  NEXT i
ENDIF

IF aHost[IM_TREEROOT]:status() > 0

  aHost[IM_TREEROOT]:lockUpdate(.t.)
  aHost[IM_TREEROOT]:destroy()
  aHost[IM_TREEROOT]:create()
  aHost[IM_TREEROOT]:lockUpdate(.t.)

  oOnLine := aHost[IM_TREEROOT]:rootItem:addItem('Online',ICON_ONLINE,ICON_ONLINE,ICON_ONLINE)
  oOffLine := aHost[IM_TREEROOT]:rootItem:addItem('Offline',ICON_OFFLINE,ICON_OFFLINE,ICON_OFFLINE)

  FOR j := 1 TO Len(aUserList)
    IF aUserList[j,USER_ONLINE]
      oTreeItem := oOnLine:addItem(aUserList[j,USER_NAME], ;
            ICON_SMILE_GREEN,;
            ICON_SMILE_GREEN,;
            ICON_SMILE_GREEN)
    ELSE
      oTreeItem := oOffLine:addItem(aUserList[j,USER_NAME], ;
            ICON_SMILE_GRAY, ;
            ICON_SMILE_GRAY, ;
            ICON_SMILE_GRAY)
    ENDIF
    oTreeItem:cargo := aUserList[j]
  NEXT

  DC_ExpandTree(aHost[IM_TREEROOT]:rootItem,.t.)
  aHost[IM_TREEROOT]:lockUpdate(.f.)

ENDIF

IF aHost[IM_BROWSE]:status() > 0
  aHost[IM_BROWSE]:dataSource := aUserList
  aHost[IM_STATUS] := 200
  IF Len(aUserList) > 0
    aHost[IM_BROWSE]:goTop()
    aHost[IM_BROWSE]:forceStable()
  ENDIF
  aHost[IM_BROWSE]:refreshAll()
ENDIF

RETURN nStatus

* ----------

METHOD IM:addUser( cHost, nPort, cUserID, cPassword, cLastName, cFirstName, ;
                   cAlias, cEmail, cAuthId, cAuthPassword )

LOCAL GetList[0], GetOptions, cMessage
LOCAL oAgent := xbSOAPEnvelope():new(), oResult, nStatus, cStatusMessage

oAgent:action := "AddUser"
oAgent:setVar('UserID',Alltrim(cUserId))
oAgent:setVar('Password',Alltrim(cPassword))
oAgent:setVar('LastName',Alltrim(cLastName))
oAgent:setVar('FirstName',Alltrim(cFirstName))
oAgent:setVar('Alias',Alltrim(cAlias))
oAgent:setVar('Email',Alltrim(cEmail))
oAgent:setVar('AuthId',Alltrim(cAuthId))
oAgent:setVar('AuthPassword',Alltrim(cAuthPassword))

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "AddUser" )

nStatus := oResult:getVar('Status')
cMessage := oResult:getVar('StatusMessage')
IF cMessage == NIL
  cMessage := '(100) Server not responding at ' + ;
              Trim(cHost) + ' Port: ' + Alltrim(Str(nPort))
ENDIF

oAgent:destroy()

RETURN cMessage

* ----------

METHOD IM:deleteUser( cHost, nPort, cUserID, cAuthId, cAuthPassword )

LOCAL GetList[0], GetOptions, cMessage
LOCAL oAgent := xbSOAPEnvelope():new(), oResult, nStatus, cStatusMessage

oAgent:action := "DeleteUser"
oAgent:setVar('UserID',Alltrim(cUserId))
oAgent:setVar('AuthId',Alltrim(cAuthId))
oAgent:setVar('AuthPassword',Alltrim(cAuthPassword))

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "DeleteUser" )

nStatus := oResult:getVar('Status')
cMessage := oResult:getVar('StatusMessage')
IF cMessage == NIL
  cMessage := '(100) Server not responding at ' + ;
              Trim(cHost) + ' Port: ' + Alltrim(Str(nPort))
ENDIF

oAgent:destroy()

RETURN cMessage

* ----------

METHOD IM:userBrowse( lQuitOnExit )

LOCAL GetList[0], GetOptions, cHostAlias, cHost, nPort, j

LOCAL oResult, nStatus, oAgent, nHosts, cTitle, ;
      cStatusMessage, i, oMyStatus, oMessengerMenu, oMenuBar, oToolBar, ;
      oStatTop, oStatBot, oActionMenu, lTagMode := .f., bTagItem, ;
      oViewMenu, aBrowPres, oTimer, cCaption, cText, oHelpMenu, ;
      oTagMenu

DEFAULT lQuitOnExit := .f.

aBrowPres := ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
    { XBP_PP_COL_DA_ROWHEIGHT, 12 },                   /* Row Height       */  ;
    { XBP_PP_COL_HA_HEIGHT, 10 },                      /* Header Height    */  ;
    { XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK },            /* Hilite FG color  */  ;
    { XBP_PP_HILITE_BGCLR, GRA_CLR_CYAN },             /* Hilite BG color  */  ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
    { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
    { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
  }

nHosts := Len(::hosts)
ASize(::soapAgents,nHosts)
ASize(::sessionIDs,nHosts)

FOR i := 1 TO nHosts
  ::server := i
  ASize(::hosts[i],IM_SIZE)
  ::hosts[i,IM_CONNECTED] := .f.
  ::hosts[i,IM_POINTER] := 0
  ::hosts[i,IM_STATUSMESSAGE] := ::hostConnectStatus('NOT CONNECTED')
  ::hosts[i,IM_STATUS] := 0
  ::hosts[i,IM_USERLISTAVAIL] := {}
  ::hosts[i,IM_USERLIST] := {}
  ::hosts[i,IM_REMOTEUSERS] := {}
  ::hosts[i,IM_GROUPLIST] := {}
  ::hosts[i,IM_USERGROUPLIST] := {}
  ::hosts[i,IM_MESSAGEWINDOW] := {}
NEXT
::server := 1
DCMENUBAR oMenuBar OWNERDRAW

  DCSUBMENU oMessengerMenu PROMPT 'Messenger' PARENT oMenuBar

    DCMENUITEM 'User Window / General Preferences' PARENT oMessengerMenu ;
       ACTION {||::editUserPreferences()} ;
       TOOLTIP 'Edit the preferences for the User Window (this window) and general preferences'

    DCMENUITEM 'Message Window Preferences' PARENT oMessengerMenu ;
       ACTION {||::editMessagePreferences()} ;
       TOOLTIP 'Edit the preferences for the Message Window'

    DCMENUITEM 'Flash this window' PARENT oMessengerMenu ;
       ACTION {||FlashTest()}

    DCMENUITEM SEPARATOR PARENT oMessengerMenu

     DCSUBMENU oMyStatus PARENT oMessengerMenu PROMPT 'My Status' ;
        WHEN {||::isOnline()}

      DCMENUITEM 'Available' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Available')}
      DCMENUITEM 'Busy' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Busy')}
      DCMENUITEM 'Stepped Out' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Stepped Out')}
      DCMENUITEM 'Be Right Back' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Be Right Back')}
      DCMENUITEM 'Not at my Desk' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Not at my Desk')}
      DCMENUITEM 'On the Phone' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Not at my Desk')}
      DCMENUITEM SEPARATOR PARENT oMyStatus
      DCMENUITEM 'Invisible to Everyone' PARENT oMyStatus ;
         ACTION {||::setUserStatus('Invisible', 1)}

  DCSUBMENU oViewMenu PROMPT 'View' PARENT oMenuBar ;
      WHEN {||::isOnline()} ;
      MESSAGE 'View menu is active when Online (connected)'

      DCMENUITEM 'View Logged On Users Only' ;
         ACTION {||::toggleViewLoggedOn()} ;
         CHECKWHEN {||::viewLoggedOn()} PARENT oViewMenu

      DCMENUITEM SEPARATOR PARENT oViewMenu

      DCMENUITEM 'Large Font' PARENT oViewMenu ;
         ACTION {||::setUserFont(3)} CHECKWHEN {||::userFont==3}

      DCMENUITEM 'Medium Font' PARENT oViewMenu ;
         ACTION {||::setUserFont(2)} CHECKWHEN {||::userFont==2}

      DCMENUITEM 'Small Font' PARENT oViewMenu ;
         ACTION {||::setUserFont(1)} CHECKWHEN {||::userFont==1}

      DCMENUITEM SEPARATOR PARENT oViewMenu

      DCMENUITEM 'View by Group' PARENT oViewMenu ;
         ACTION {||::pickGroups(),::refreshUsers(::server,nil,.f.)} ;
         MESSAGE 'View only users who belong to a specified group'

      DCMENUITEM 'Tree View' ;
         ACTION {||::treeView := !::treeView, ;
                   DC_GetRefresh(GetList)} ;
         CHECKWHEN {||::treeView} PARENT oViewMenu ;
         MESSAGE 'Toggle TreeView or Columnar Browse when viewing users'

  DCSUBMENU oActionMenu PROMPT 'Action' PARENT oMenuBar ;
         WHEN {||::isOnline()} ;
         MESSAGE 'Action Menu is active when connected (Online)'

      DCMENUITEM 'Refresh User List' ;
         ACTION {||::refreshUsers(::server,nil,.t.)} PARENT oActionMenu

      DCMENUITEM 'Send Email' PARENT oActionMenu ;
         ACTION {||::sendEmail()}

      DCMENUITEM SEPARATOR PARENT oActionMenu

      DCMENUITEM 'Send Message to Group' PARENT oActionMenu ;
         ACTION {||::sendGroupMessageWindow()}

      DCMENUITEM SEPARATOR PARENT oActionMenu

      DCSUBMENU oTagMenu PROMPT 'Tag Users' PARENT oActionMenu

        DCMENUITEM 'UnTag All Users' PARENT oTagMenu ;
           ACTION {||::tagUsers(0)}

        DCMENUITEM 'Tag All Users' PARENT oTagMenu ;
           ACTION {||::tagUsers(1)}

        DCMENUITEM 'Tag All Logged ON Users' PARENT oTagMenu ;
           ACTION {||::tagUsers(2)}

        DCMENUITEM 'Tag All Logged OFF Users' PARENT oTagMenu ;
           ACTION {||::tagUsers(3)}

      DCMENUITEM SEPARATOR PARENT oActionMenu

      DCMENUITEM 'Send a Message to Tagged Users' PARENT oActionMenu ;
         ACTION {||::sendTaggedMessageWindow()}

      DCMENUITEM 'Start a Conference with Tagged Users' PARENT oActionMenu ;
         ACTION {||::messageWindowConference()}

      DCMENUITEM SEPARATOR PARENT oActionMenu

      DCMENUITEM 'Set Photo' ACTION {||::setPhoto(::server,self)} PARENT oActionMenu ;
         TOOLTIP 'Choose a Photo file to share with other users'

  DCSUBMENU oHelpMenu PROMPT 'Help' PARENT oMenuBar

    DCMENUITEM 'Display Help Page' PARENT oHelpMenu ;
      ACTION {||RunExplorerHelp(self)}

    DCMENUITEM 'About IM Client' PARENT oHelpMenu ;
      ACTION {||AboutIM()}

IF !Empty(::userWindowHotButtons)

  DCSTATUSBAR oStatTop ALIGN DCGUI_ALIGN_TOP HEIGHT 30

  @ 0,0 DCTOOLBAR oToolBar SIZE 100, 30 PARENT oStatTop PIXEL BUTTONSIZE 40, 30 ;
        TYPE XBPSTATIC_TYPE_RAISEDBOX ;
        WHEN {|n|n:=::getServer(),::hosts[n,IM_CONNECTED]}

  FOR i := 1 TO Len(::userWindowHotButtons)

    cCaption := Substr(::userWindowHotButtons[i],1,At('|',::userWindowHotButtons[i])-1)
    cText := Substr(::userWindowHotButtons[i],At('|',::userWindowHotButtons[i])+1)

    IF Empty(cCaption) .OR. Empty(cText)
      LOOP
    ENDIF

    DCADDBUTTON ;
      CAPTION 'F' + Alltrim(Str(i)) + ';' + cCaption ;
      PARENT oToolBar  ;
      ACCELKEY xbeK_F1 + (i-1) ;
      CARGO cText ;
      TOOLTIP cText ;
      ACTION {|a,b,o|::hotButtonMessage(o)} ;
      ALIGNCAPTION BS_MULTILINE

  NEXT

ENDIF

DCSTATUSBAR oStatBot ALIGN DCGUI_ALIGN_BOTTOM HEIGHT 20

@ 0,0 DCSAY '' SAYSIZE 200,20 PIXEL COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '8.Arial' OBJECT ::messageBox PARENT oStatBot

@ 0,1 DCPROGRESS ::progress SIZE 150,16 PIXEL ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_CYAN, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC ;
      PARENT oStatBot

FOR i := 1 TO Len(::hosts)

  IF Len(::hosts) > 1
    IF i == 1
      @ 0,0 DCTABPAGE ::hosts[i,IM_TABPAGE] SIZE 70, 20 ;
            CAPTION ::hosts[i,IM_HOST_ALIAS] RESIZE DCGUI_RESIZE_RESIZEONLY ;
            GOTFOCUS TabGotFocusBlock(self,i,GetList)
    ELSE
      @ 0,0 DCTABPAGE ::hosts[i,IM_TABPAGE] RELATIVE ::hosts[i-1,IM_TABPAGE] ;
            CAPTION ::hosts[i,IM_HOST_ALIAS] RESIZE DCGUI_RESIZE_RESIZEONLY ;
            GOTFOCUS TabGotFocusBlock(self,i,GetList)
    ENDIF
  ENDIF

  @ 1.5,2 DCBROWSE ::hosts[i,IM_BROWSE] SIZE 66,15.5 ;
          PRESENTATION aBrowPres ;
          FONT ::setUserFont(,1);
          DATA ::hosts[i,IM_USERLIST] ;
          ;// CURSORMODE XBPBRW_CURSOR_ROW ;
          PARENT ::hosts[i,IM_TABPAGE] ;
          POINTER ::hosts[i,IM_POINTER] ;
          CARGO 1 ;
          ITEMSELECTED {||::userConnect(::server)} ;
          COLOR ColorBlock( self, i ) ;
          HIDE BrowseHideBlock(self,i) ;
          FREEZELEFT {1,2} ;
          RESIZE DCGUI_RESIZE_RESIZEONLY ;
          ID 'IM_USER_BROWSE_' + Alltrim(Str(i))

  @ 1.5, 2 DCTREEROOT OBJECT ::hosts[i,IM_TREEROOT] SIZE 66,15.5 ;
          PARENT ::hosts[i,IM_TABPAGE] ;
          HASBUTTONS ;
          HASLINES ;
          ALWAYSSHOWSELECTION ;
          FONT ::setUserFont(,2) ;
          ITEMSELECTED {|a,b,o|::userConnect(::server,o)} ;
          ITEMMARKED {|a,b,o|::tagToggle(o)} ;
          HIDE TreeViewHideBlock(self,i) ;
          RESIZE DCGUI_RESIZE_RESIZEONLY ;
          ID 'IM_USER_TREE_' + Alltrim(Str(i))

  bTagItem := {|o|o:dataarea:LbClick := {|a,b,o|::tagToggle(o)}}

  DCBROWSECOL DATA ArrayPointerBlock(self,i) HEADER '#' WIDTH 2 ;
       PICTURE '999' PARENT ::hosts[i,IM_BROWSE] EVAL bTagItem

  /*
  DCBROWSECOL ELEMENT USER_ID PARENT ::hosts[i,IM_BROWSE] HEADER 'User ID' ;
       WIDTH 10 EVAL bTagItem
  */

  DCBROWSECOL ELEMENT USER_NAME HEADER 'Name' WIDTH 15 PARENT ::hosts[i,IM_BROWSE] ;
       EVAL bTagItem

  DCBROWSECOL ELEMENT USER_ALIAS PARENT ::hosts[i,IM_BROWSE] HEADER 'Alias' ;
       WIDTH 7 EVAL bTagItem

  DCBROWSECOL DATA DataBlock( self, i ) ;
       PARENT ::hosts[i,IM_BROWSE] HEADER 'OnLine' ;
       WIDTH 6 EVAL bTagItem

  DCBROWSECOL ELEMENT USER_STATUS PARENT ::hosts[i,IM_BROWSE] HEADER 'Status' ;
       WIDTH 20 EVAL bTagItem

  DCBROWSECOL ELEMENT USER_EMAIL PARENT ::hosts[i,IM_BROWSE] HEADER 'E-Mail Address' ;
       WIDTH 20 EVAL bTagItem

  DCBROWSECOL ELEMENT USER_GROUP PARENT ::hosts[i,IM_BROWSE] HEADER 'Group(s)' ;
       WIDTH 20 EVAL bTagItem

  DCBROWSECOL ELEMENT USER_CLIENT_VER PARENT ::hosts[i,IM_BROWSE] HEADER 'Client Version' ;
       WIDTH 20 EVAL bTagItem

  @ 1.5,2 DCMULTILINE ::hosts[i,IM_STATUSMESSAGE] SIZE 66,15.5 ;
          FONT '8.Lucida Console' ;
          PARENT ::hosts[i,IM_TABPAGE] ;
          HIDE MemoHideBlock(self,i) ;
          RESIZE DCGUI_RESIZE_RESIZEONLY

  @ 18, 2 DCPUSHBUTTON CAPTION ButtonCaptionBlock(self,i) SIZE 12 ;
          ACTION ButtonActionBlock(self,i) ;
          PARENT ::hosts[i,IM_TABPAGE]

  @ DCGUI_ROW, DCGUI_COL + 20 DCSAY 'Groups:' SAYSIZE 0 PARENT ::hosts[i,IM_TABPAGE]
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY {||::groupList()} SAYSIZE 40 SAYLEFT ;
      COLOR GRA_CLR_BLUE FONT '10.Lucida Console' PARENT ::hosts[i,IM_TABPAGE]

NEXT

DCGETOPTIONS ;
   RESIZE ;
   FITPAD 4 ;
   MESSAGEINTO {|c|::messageBox:setCaption(c)}

cTitle := 'Instant Messenger ( ' + ::firstName + ' ' + ::lastName + ' )'

IF DC_IsAppRunning('XbpDialog',cTitle,'IMCLIENT.EXE',.t.)
  RETURN .f.
ENDIF

DCREAD GUI ;
   FIT ;
   HANDLER userBrowseHandler REFERENCE self ;
   SETAPPWINDOW ;
   TITLE cTitle ;
   OPTIONS GetOptions ;
   EVAL {|o|::userBrowseGetList := GetList, ;
            ::userBrowseActive := .t., ;
            ::userBrowseWindow := o, ;
            oTimer := DC_SetTimerEvent():new(500,{||CheckForShutDown()}), ;
            DC_GetWhen(GetList)}

oTimer:destroy()
::userBrowseActive := .f.
::userBrowseWindow := nil

FOR i := 1 TO Len(::hosts)
  IF ::hosts[i,IM_CONNECTED]
    oAgent := xbSOAPEnvelope():new()
    oAgent:action := "LogOff"
    oAgent:setVar('UserID',::hosts[i,IM_LOCALUSER_ID])
    oAgent:setVar('Password',::hosts[i,IM_LOCALUSER_PASSWORD])
    oResult := oAgent:Execute( ::hosts[i,IM_HOST_NAME] + ":" + NTrim(::hosts[i,IM_HOST_PORT]), "LogOff" )
    oAgent:destroy()
  ENDIF
  IF Valtype(::hosts[i,IM_MESSAGEWINDOW]) == 'O'
    PostAppEvent(xbeP_Close,,,::hosts[i,IM_MESSAGEWINDOW])
    Sleep(10)
  ENDIF
NEXT

IF lQuitOnExit
  Sleep(50)
  QUIT
ENDIF

RETURN nil

* ----------

METHOD IM:toggleViewLoggedOn()

::hosts[::server,IM_ONLINE_ONLY] := !::hosts[::server,IM_ONLINE_ONLY]
DC_GetWhen(::userBrowseGetList)
::refreshUsers(::server,nil,.t.)

RETURN nil

* ----------

METHOD IM:viewLoggedOn()

RETURN ::hosts[::server,IM_ONLINE_ONLY]

* ----------

METHOD IM:tagUsers( nMode )

LOCAL aUserList, i

aUserList := ::hosts[::server,IM_BROWSE]:dataSource

IF nMode = 0  // Untag All
  FOR i := 1 TO Len(aUserList)
    aUserList[i,USER_TAG] := .f.
  NEXT
ELSEIF nMode = 1  // Tag All
  FOR i := 1 TO Len(aUserList)
    aUserList[i,USER_TAG] := .t.
  NEXT
ELSEIF nMode = 2  // Tag All Logged On
  FOR i := 1 TO Len(aUserList)
    IF aUserList[i,8]
      aUserList[i,USER_TAG] := .t.
    ENDIF
  NEXT
ELSEIF nMode = 3  // Tag All Logged Off
  FOR i := 1 TO Len(aUserList)
    IF !aUserList[i,8]
      aUserList[i,USER_TAG] := .t.
    ENDIF
  NEXT
ENDIF

UpdateIcons( ::hosts[::server,IM_TREEROOT]:rootItem )

RETURN nil

* ----------

METHOD IM:tagToggle( o )

LOCAL i, aUserList, nPointer, aUser, oTreeItem, nIcon, ;
      nLastPointer, oLastTreeItem, aChildList, oParent


aUserList := ::hosts[::server,IM_BROWSE]:dataSource

IF o:isDerivedFrom('XbpTreeView')
  oTreeItem := o:getData()
  IF Empty(oTreeItem)
    RETURN .f.
  ENDIF
  aUser := oTreeItem:cargo
  IF Empty(aUser)
    RETURN .f.
  ENDIF
  IF AppKeyState(xbeK_CTRL) == 1
    aUser[10] := !aUser[10]
    nIcon := IIF(aUser[8],ICON_SMILE_YELLOW,ICON_SMILE_GRAY)
    oTreeItem:setImage(IIF(aUser[10],ICON_SMILE_YELLOW,nIcon))
    oTreeItem:setMarkedImage(IIF(aUser[10],ICON_SMILE_YELLOW,nIcon))
    DC_GetCargo(o,oTreeItem)
  ELSEIF AppKeyState(xbeK_SHIFT) == 1
    FOR i := 1 TO Len(aUserList)
      aUserList[i,USER_TAG] := .f.
    NEXT
    nLastPointer := 1
    oParent := oTreeItem:getParentItem()
    aChildList := oParent:getChildItems()
    oLastTreeItem := DC_GetCargo(::hosts[::server,IM_TREEROOT])
    IF Valtype(oLastTreeItem) # 'O'
      oLastTreeItem := aChildList[1]
    ENDIF
    FOR i := 1 TO Len(aChildList)
      IF aChildList[i] == oLastTreeItem
        nLastPointer := i
      ELSEIF aChildList[i] == oTreeItem
        nPointer := i
      ENDIF
    NEXT
    IF nLastPointer >= nPointer
      FOR i := nLastPointer TO nPointer STEP -1
        aUser := aChildList[i]:cargo
        aUser[10] := .t.
      NEXT
    ELSE
      FOR i := nLastPointer TO nPointer
        aUser := aChildList[i]:cargo
        aUser[10] := .t.
      NEXT
    ENDIF
    UpdateIcons( o:rootItem )
  ELSEIF AScan(aUserList,{|a|a[USER_TAG]}) > 0
    DC_GetCargo(o,oTreeItem)
    FOR i := 1 TO Len(aUserList)
      aUserList[i,USER_TAG] := .f.
    NEXT
    UpdateIcons( o:rootItem )
  ENDIF
ELSE
  nPointer := ::hosts[::server,IM_POINTER]
  aUserList := ::hosts[::server,IM_BROWSE]:dataSource
  IF AppKeyState(xbeK_CTRL) == 1
    aUserList[nPointer,USER_TAG] := !aUserList[nPointer,USER_TAG]
    ::hosts[::server,IM_BROWSE]:refreshCurrent()
    DC_GetCargo(::hosts[::server,IM_BROWSE],nPointer)
  ELSEIF AppKeyState(xbeK_SHIFT) == 1
    nLastPointer := DC_GetCargo(::hosts[::server,IM_BROWSE])
    FOR i := 1 TO Len(aUserList)
      aUserList[i,USER_TAG] := .f.
    NEXT
    IF nLastPointer >= nPointer
      FOR i := nLastPointer TO nPointer STEP -1
        aUserList[i,USER_TAG] := .t.
      NEXT
    ELSE
      FOR i := nLastPointer TO nPointer
        aUserList[i,USER_TAG] := .t.
      NEXT
    ENDIF
    ::hosts[::server,IM_BROWSE]:refreshAll()
  ELSE
    DC_GetCargo(::hosts[::server,IM_BROWSE],nPointer)
    FOR i := 1 TO Len(aUserList)
      aUserList[i,USER_TAG] := .f.
    NEXT
    ::hosts[::server,IM_BROWSE]:refreshAll()
  ENDIF
ENDIF

RETURN nil

* ----------

STATIC FUNCTION UpdateIcons( oTreeItem )

LOCAL aChildList, i, nIcon, aUser

aChildList := oTreeItem:getChildItems()
FOR i := 1 TO Len(aChildList)
  oTreeItem := aChildList[i]
  aUser := oTreeItem:cargo
  IF Valtype(aUser) == 'A'
    nIcon := IIF(aUser[USER_ONLINE],ICON_SMILE_YELLOW,ICON_SMILE_GRAY)
    oTreeItem:setImage(IIF(aUser[USER_TAG],ICON_SMILE_YELLOW,nIcon))
    oTreeItem:setMarkedImage(IIF(aUser[USER_TAG],ICON_SMILE_YELLOW,nIcon))
  ELSE
    UpdateIcons( oTreeItem )
  ENDIF
NEXT

RETURN nil

* ----------

METHOD IM:hotButtonMessage(oButton)

LOCAL lSend := .f., cMessage := DC_GetCargo(oButton), cWaveFile, aTokens, ;
      nPointer, cRemoteUser, aUser, cName, oTreeItem

IF !Empty(cMessage)
  aTokens := DC_TokenArray(cMessage,'|')
  ASize(aTokens,2)
  cMessage := aTokens[1]
  cWaveFile := aTokens[2]
  IF '^' $ cMessage
    lSend := .t.
    cMessage := Strtran(cMessage,'^','')
  ENDIF
ENDIF

IF ::treeView
  oTreeItem := ::hosts[::server,IM_TREEROOT]:getData()
  IF Valtype(oTreeItem) == 'O'
    aUser := oTreeItem:cargo
  ENDIF
ELSE
  nPointer := ::hosts[::server,IM_POINTER]
  aUser := ::hosts[::server,IM_BROWSE]:dataSource[nPointer]
ENDIF

IF Empty(aUser)
  DC_WinAlert('Must select a user')
  RETURN .f.
ENDIF

cRemoteUser := aUser[USER_ID]
cName := aUser[USER_NAME]

lSend := .f.

RETURN ::sendAlertMessage( { cRemoteUser }, cMessage, cWaveFile, lSend, cName )

* --------------

METHOD IM:hostConnect()

Thread():new():start({||::waitForMessage(::server)})

RETURN self

* --------------

METHOD IM:hostDisconnect()

LOCAL oAgent, oResult

IF !::hosts[::server,IM_CONNECTED]
  RETURN self
ENDIF

oAgent := xbSOAPEnvelope():new()
oAgent:action := "LogOff"
oAgent:setVar('UserID',::hosts[::server,IM_LOCALUSER_ID])
oAgent:setVar('Password',::hosts[::server,IM_LOCALUSER_PASSWORD])
oResult := oAgent:Execute( ::hosts[::server,IM_HOST_NAME] + ":" + NTrim(::hosts[::server,IM_HOST_PORT]), "LogOff" )
oAgent:destroy()

::hosts[::server,IM_CONNECTED] := .f.
::hosts[::server,IM_STATUSMESSAGE] := ::hostConnectStatus('DISCONNECTED')

DC_GetRefresh(::userBrowseGetList)

IF Valtype(::hosts[::server,IM_MESSAGEWINDOW]) == 'O'
  PostAppEvent(xbeP_Close,,,::hosts[::server,IM_MESSAGEWINDOW])
  Sleep(10)
ENDIF

RETURN self

* --------------

METHOD IM:hostConnectStatus( cMessage)

LOCAL cStatus

cStatus := '  Host Name: ' + ::hosts[::server,IM_HOST_NAME] + CRLF
cStatus += '  Host Port: ' + DC_XtoC(::hosts[::server,IM_HOST_PORT]) + CRLF
cStatus += ' Host Alias: ' + ::hosts[::server,IM_HOST_ALIAS] + CRLF + CRLF
cStatus += '    User ID: ' + ::hosts[::server,IM_LOCALUSER_ID] + CRLF
cStatus += ' User Alias: ' + ::hosts[::server,IM_LOCALUSER_ALIAS] + CRLF
cStatus += CRLF

cStatus += '    Status: ' + cMessage

RETURN cStatus

* --------------

METHOD IM:userconnect( nServer, oTreeItem )

LOCAL oConn, nPointer, aRemoteUsers, cRemoteUser, lStatus, lLoggedIn, ;
      cName

DEFAULT nServer := ::server

IF Valtype(oTreeItem) == 'O'
  aRemoteusers := oTreeItem:getData():cargo
  IF Empty(aRemoteUsers)
     RETURN .f.
  ENDIF
  lLoggedIn := aRemoteUsers[USER_ONLINE]
  cRemoteUser := aRemoteUsers[USER_ID]
  cName := aRemoteUsers[USER_NAME]
ELSE
  nPointer := ::hosts[::server,IM_POINTER]
  aRemoteUsers := ::hosts[::server,IM_USERLIST]
  lLoggedIn := aRemoteUsers[nPointer,USER_ONLINE]
  cRemoteUser := aRemoteUsers[nPointer,USER_ID]
  cName := aRemoteUsers[nPointer,USER_NAME]
ENDIF

IF lLoggedIn
  ::hosts[::server,IM_REMOTEUSERS] := { cRemoteUser }
  oConn := IMConnection():new( self, ::server )
  Thread():new():start({||oConn:MessageWindow(.t.)})
ELSE
  DCMSGBOX 'Cannot IM a user who is not Logged-In!', ;
           '', ;
           'Would you like to send an alert message', ;
           'that will display when the user logs in', ;
           'to the IM server?' YESNO TO lStatus
  IF lStatus
    ::sendAlertMessage( { cRemoteUser },,,,cName )
  ENDIF
ENDIF

RETURN .t.

* ----------------

METHOD IM:sendAlertMessage( aRemoteUsers, cMessage, ;
                            cWaveFile, lSend, cName )

LOCAL GetList[0], GetOptions, cList, lStatus, ;
      oAgent, oResult, nStatus, cStatusMessage

DEFAULT lSend := .f., ;
        cMessage := '', ;
        cName := aRemoteUsers[1]

IF !lSend

  IF Len(aRemoteUsers) == 1
    cList := cName
  ELSE
    cList := '( List )'
  ENDIF

  @ 0,0 DCSAY 'Message to: ' SAYSIZE 0 ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY cList SAYSIZE 0 COLOR GRA_CLR_BLUE ;
        FONT '12.Courier New Bold'

  @ 2,0 DCSAY 'Enter the text of your message below:' SAYSIZE 0 ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ DCGUI_ROW, DCGUI_COL + 30 DCPUSHBUTTON CAPTION 'Attach Audible' ;
        SIZE 20 ACTION {||cWaveFile := Audible(,,,,,.t.)} ;
        RESIZE DCGUI_RESIZE_REPOSONLY_Y

  @ 3,0 DCMULTILINE cMessage SIZE 50,10 FONT '10.Courier New' ;
        NOHSCROLL RESIZE DCGUI_RESIZE_RESIZEONLY

  DCGETOPTIONS RESIZE
  DCREAD GUI ;
    FIT ;
    ADDBUTTONS ;
    TO lStatus ;
    OPTIONS GetOptions ;
    TITLE 'Send Alert Message' ;
    MODAL ;
    SETAPPWINDOW

ELSE

  lStatus := .t.

ENDIF

IF !lStatus .OR. Empty(cMessage)
  RETURN .f.
ENDIF

oAgent := XbSOAPEnvelope():new()
oAgent:action := "SendMessage"
oAgent:setVar('ToUserList',aRemoteUsers)
oAgent:setVar('FromUser',Alltrim(::hosts[::server,IM_LOCALUSER_ID]))
oAgent:setVar('Password',Alltrim(::hosts[::server,IM_LOCALUSER_PASSWORD]))
oAgent:setVar('MessageType',2)
oAgent:setVar('Message',cMessage)
IF !Empty(cWaveFile)
  oAgent:setVar('WaveFile',cWaveFile)
ENDIF

oResult := oAgent:Execute( Trim(::hosts[::server,IM_HOST_NAME]) + ":" + ;
                           NTrim(::hosts[::server,IM_HOST_PORT]), "SendMessage" )

nStatus := oResult:getVar('Status')
cStatusMessage := oResult:getVar('StatusMessage')

DCMSGBOX cStatusMessage

oAgent:destroy()

RETURN .t.

* ----------------

METHOD IM:setUserFont( nFont, nMode )

LOCAL aBrowPres, nHeight, cFont, i, aHost, oBrowse, ;
      oTreeRoot, cBrowseFont, cTreeFont

IF Valtype(nFont) == 'N'
  ::userFont := nFont
ENDIF

IF ::userFont = 1
  nHeight := 9
  cBrowseFont := '7.Arial'
  cTreeFont := '8.Lucida Console'
ELSEIF ::userFont = 2
  nHeight := 11
  cBrowseFont := '9.Arial'
  cTreeFont := '10.Lucida Console'
ELSEIF ::userFont = 3
  nHeight := 15
  cBrowseFont := '11.Arial'
  cTreeFont := '11.Lucida Console'
ENDIF

aBrowPres := ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         ;
    { XBP_PP_COL_DA_ROWHEIGHT, nHeight },              ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            ;
    { XBP_PP_COL_DA_COMPOUNDNAME, cBrowseFont }        ;
  }

IF Valtype(nFont) == 'N'

  aHost := ::hosts[::server]
  oBrowse := aHost[IM_BROWSE]
  oTreeRoot := aHost[IM_TREEROOT]
  oTreeRoot:setFontCompoundName(cTreeFont)

  FOR i := 1 TO oBrowse:colcount
    oBrowse:getColumn(i):setPresParam(aBrowPres)
    oBrowse:getColumn(i):configure()
  NEXT

  oBrowse:refreshAll()
  oBrowse:setSize(oBrowse:currentSize())
  DC_GetRefresh(::userBrowseGetList)

ENDIF

IF Valtype(nMode) == 'N'
  IF nMode == 1
    cFont := cBrowseFont
  ELSE
    cFont := cTreeFont
  ENDIF
ELSE
  cFont := ''
ENDIF

RETURN cFont

* ----------------

METHOD IM:refreshBrowses()

LOCAL i, oBrowse

FOR i := 1 TO Len(::hosts)
  oBrowse := ::hosts[i,IM_BROWSE]
  oBrowse:goTop()
  oBrowse:forceStable()
  oBrowse:refreshAll()
NEXT

RETURN self

* ----------------

METHOD IM:sendGroupMessageWindow()

LOCAL GetList[0], GetOptions, oAgent := xbSOAPEnvelope():new(), ;
      oStatus, cGroupName, oStatTop, oStatBot, oToolBar, oBrowse, ;
      cHost, nPort, oResult, aGroupArray, nPointer := 1, cMessage := '', ;
      oMessage, nStatus, cStatusMessage, i, lOnlineOnly := .f.

oAgent:action := "GetGroups"
oAgent:setVar('UserID',Alltrim(::hosts[::server,IM_LOCALUSER_ID]))
oAgent:setVar('Password',Alltrim(::hosts[::server,IM_LOCALUSER_PASSWORD]))

cHost := ::hosts[::server,IM_HOST_NAME]
nPort := ::hosts[::server,IM_HOST_PORT]

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "GetGroups" )

nStatus := oResult:getVar('Status')
cStatusMessage := oResult:getVar('StatusMessage')

oAgent:destroy()

IF nStatus == NIL
  DC_WinAlert('(100) Server not responding at ' + ;
               Trim(cHost) + ' Port: ' + Alltrim(Str(nPort)))
  RETURN .f.
ENDIF

aGroupArray := oResult:getVar("GroupList")
IF Valtype(aGroupArray) # 'A'
  aGroupArray := Array(0)
ENDIF

DCSTATUSBAR oStatTop ALIGN DCGUI_ALIGN_TOP HEIGHT 25

@ 0,0 DCTOOLBAR oToolBar SIZE 300,25 PIXEL ;
   PARENT oStatTop BUTTONSIZE 120, 25

DCADDBUTTON CAPTION 'Send Message' PARENT oToolBar ;
   WHEN {||Valtype(oMessage)=='O' .AND. !Empty(oMessage:editBuffer()) .AND. ;
           !Empty(aGroupArray)} ;
   ID 'SEND' ;
   ACTION {||oMessage:getData(), ;
             cGroupName := aGroupArray[nPointer,1], ;
             ::sendMessageToGroup( cGroupName, cHost, nPort, ;
                                   cMessage,, oStatus, lOnlineOnly ) }

DCADDBUTTON CAPTION 'Audible' PARENT oToolBar ;
   WHEN {||!Empty(aGroupArray)} ;
   ACTION  {||cGroupName := aGroupArray[nPointer,1], ;
              Audible(self,cHost,nPort,cGroupName,oStatus)}

DCSTATUSBAR oStatBot ALIGN DCGUI_ALIGN_BOTTOM HEIGHT 20

@ 0,0 DCSAY '' SAYSIZE 200,20 PIXEL COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '10.Lucida Console' OBJECT oStatus PARENT oStatBot

@ 0,0 DCBROWSE oBrowse DATA aGroupArray SIZE 60,10 FIT ;
      PRESENTATION DC_BrowPres() ;
      FONT '10.Lucida Console' ;
      POINTER nPointer ;
      CURSORMODE XBPBRW_CURSOR_ROW ;
      NOHSCROLL

DCBROWSECOL ELEMENT 1 HEADER 'Group Name' WIDTH 15 PARENT oBrowse

DCBROWSECOL ELEMENT 2 HEADER 'Group Description' WIDTH 35 PARENT oBrowse

@ 10,0 DCCHECKBOX lOnlineOnly PROMPT 'Send only to users who are Online' ;
      TOOLTIP 'Uncheck this if you want users who are not online;' + ;
              'to receive this message when they connect to IM server.;' + ;
              'Check to send message immediately to online users in this group'

@ 12,0 DCMULTILINE cMessage SIZE 60,8 FONT '8.Lucida Console' ;
      NOHSCROLL OBJECT oMessage ;
      EVAL {|o|o:keyboard := {||DC_GetRefresh(GetList,'SEND')}}

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   AUTORESIZE

DCREAD GUI ;
   FIT ;
   MODAL ;
   SETAPPWINDOW ;
   OPTIONS GetOptions ;
   TITLE 'Send Message to Group'

RETURN self

* ----------------

METHOD IM:sendTaggedMessageWindow()

LOCAL GetList[0], GetOptions, nTab, i, oConn, cHost, nPort, ;
      oStatus, cGroupName, oStatTop, oStatBot, oToolBar, ;
      cMessage := '', oMessage, aRemoteUsers[0], ;
      cLocalUser, aUsers

cLocalUser := ::hosts[::server,IM_LOCALUSER_ID]
aUsers := ::hosts[::server,IM_BROWSE]:dataSource
FOR i := 1 TO Len(aUsers)
  IF aUsers[i,USER_TAG] .AND. ;
      !(Alltrim(Upper(aUsers[i,USER_ID]))) == Upper(Alltrim(cLocalUser))
    AAdd( aRemoteUsers, aUsers[i,USER_ID] )
  ENDIF
NEXT

IF Empty(aRemoteUsers)
  DC_WinAlert('No Users Selected!')
  RETURN self
ENDIF

oConn := IMConnection():new( self, ::server )
oConn:remoteUsers := aRemoteUsers

cHost := ::hosts[::server,IM_HOST_NAME]
nPort := ::hosts[::server,IM_HOST_PORT]

DCSTATUSBAR oStatTop ALIGN DCGUI_ALIGN_TOP HEIGHT 25

@ 0,0 DCTOOLBAR oToolBar SIZE 300,25 PIXEL ;
   PARENT oStatTop BUTTONSIZE 120, 25

DCADDBUTTON CAPTION 'Send Message' PARENT oToolBar ;
   WHEN {||Valtype(oMessage)=='O' .AND. !Empty(oMessage:editBuffer()) .AND. ;
           !Empty(aRemoteUsers)} ;
   ID 'SEND' ;
   ACTION {||oMessage:getData(), ;
             oConn:sendMessage(,,aRemoteUsers,,cMessage,oStatus ), ;
             cMessage := '', ;
             DC_GetRefresh(GetList) }

DCADDBUTTON CAPTION 'Audible' PARENT oToolBar ;
   WHEN {||!Empty(aRemoteUsers)} ;
   ACTION  {||Audible(oConn,cHost,nPort,,oStatus)}

DCSTATUSBAR oStatBot ALIGN DCGUI_ALIGN_BOTTOM HEIGHT 20

@ 0,0 DCSAY '' SAYSIZE 200,20 PIXEL COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '10.Lucida Console' OBJECT oStatus PARENT oStatBot

@ 10,0 DCMULTILINE cMessage SIZE 60,10 FONT '8.Lucida Console' ;
      NOHSCROLL OBJECT oMessage ;
      EVAL {|o|o:keyboard := {||DC_GetRefresh(GetList,'SEND')}}

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   AUTORESIZE

DCREAD GUI ;
   FIT ;
   MODAL ;
   SETAPPWINDOW ;
   OPTIONS GetOptions ;
   TITLE 'Send Message to Tagged Users'

RETURN self

* ----------------

METHOD IM:getServer( nServer )

LOCAL i

IF Empty(nServer)
  FOR i := 1 TO Len(::hosts)
    IF ::hosts[i,IM_TABPAGE] == nil
      nServer := 1
      EXIT
    ELSEIF !::hosts[i,IM_TABPAGE]:minimized
      nServer := i
      EXIT
    ENDIF
  NEXT
ENDIF

RETURN nServer

* ----------------

METHOD IM:messageWindowConference()

LOCAL aRemoteUsers[0], aRemoteUsersLastName[0], aRemoteUsersFirstName[0], ;
      aRemoteUsersAlias[0], aRemoteUsersEmail[0], i, oConn, cLocalUser, ;
      aUsers

aUsers := ::hosts[::server,IM_BROWSE]:dataSource
cLocalUser := ::hosts[::server,IM_LOCALUSER_ID]

FOR i := 1 TO Len(aUsers)
  IF aUsers[i,USER_TAG] .AND. ;
      !(Alltrim(Upper(aUsers[i,1]))) == Upper(Alltrim(cLocalUser))
    AAdd( aRemoteUsers, Upper(Alltrim(aUsers[i,USER_ID])) )
    AAdd( aRemoteUsersLastName, aUsers[i,USER_LAST] )
    AAdd( aRemoteUsersFirstName, aUsers[i,USER_FIRST] )
    AAdd( aRemoteUsersAlias, aUsers[i,USER_ALIAS] )
    AAdd( aRemoteUsersEmail, aUsers[i,USER_EMAIL] )
  ENDIF
NEXT

IF Empty(aRemoteUsers)
  DC_WinAlert('No Users Selected!')
  RETURN self
ENDIF

oConn := IMConnection():new( self, ::server )
oConn:host := ::hosts[::server,IM_HOST_NAME]
oConn:port := ::hosts[::server,IM_HOST_PORT]
oConn:remoteUsers := aRemoteUsers
oConn:remoteUsersLastName := aRemoteUsersLastName
oConn:remoteUsersFirstName := aRemoteUsersFirstName
oConn:remoteUsersAlias := aRemoteUsersAlias
oConn:remoteUsersEmail := aRemoteUsersEmail
Thread():new():start({||oConn:MessageWindow()})

Sleep(100)

RETURN self

* ----------

METHOD IM:sendMessageToGroup( cGroupName, cHost, nPort, ;
                              cMessage, cWaveFile, oStatus, lOnlineOnly )

LOCAL oAgent := xbSOAPEnvelope():new(), oResult, nStatus, cStatusMessage

oAgent:action := "SendGroupMessage"
oAgent:setVar('GroupName',cGroupName)
oAgent:setVar('FromUser',Alltrim(::hosts[::server,IM_LOCALUSER_ID]))
oAgent:setVar('Password',Alltrim(::hosts[::server,IM_LOCALUSER_PASSWORD]))
oAgent:setVar('Message',cMessage)
oAgent:setVar('WaveFile',cWaveFile)
oAgent:setVar('MessageType',2)
oAgent:setVar('OnlineOnly',lOnlineOnly)

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "SendGroupMessage" )

nStatus := oResult:getVar('Status')
cStatusMessage := oResult:getVar('StatusMessage')

IF nStatus == NIL
  oStatus:setCaption('(100) Server not responding at ' + ;
               Trim(::host) + ' Port: ' + Alltrim(Str(::port)))
ELSEIF nStatus >= 900
  oStatus:setCaption(cStatusMessage)
ELSEIF nStatus # 207
  oStatus:setCaption( cStatusMessage )
ELSEIF !Empty(cMessage)
  oStatus:setCaption( 'Message Sent!!' )
ELSEIF !Empty(cWaveFile)
  oStatus:setCaption( 'Audible Sent!!' )
ENDIF

oAgent:destroy()
Sleep(10)

RETURN self

* ----------------

METHOD IM:setUserStatus( cStatus, nMode )

LOCAL oAgent := xbSOAPEnvelope():new(), oResult, nStatus, i, ;
      cHost, nPort, cMessage

oAgent:action := "SetUserStatus"
oAgent:setVar('UserID',Alltrim(::hosts[::server,IM_LOCALUSER_ID]))
oAgent:setVar('Password',Alltrim(::hosts[::server,IM_LOCALUSER_PASSWORD]))
oAgent:setVar('Status',cStatus)
oAgent:setVar('Mode',nMode)
oAgent:action := 'SetUserStatus'

cHost := ::hosts[::server,IM_HOST_NAME]
nPort := ::hosts[::server,IM_HOST_PORT]

oResult := oAgent:Execute( Trim(cHost) + ":" + NTrim(nPort), "SetUserStatus" )

nStatus := oResult:getVar('Status')
cMessage := oResult:getVar('StatusMessage')
IF cMessage == NIL
  cMessage := '(100) Server not responding at ' + ;
                Trim(cHost) + ' Port: ' + Alltrim(Str(nPort))
ENDIF

IF Valtype(::messageBox) == 'O'
  ::messageBox:setCaption(cMessage)
ENDIF

RETURN cMessage

* ----------------

STATIC FUNCTION DataBlock( oIM, i )

RETURN {|n|n:=oIM:hosts[i,IM_BROWSE]:arrayElement, ;
           IIF(n<=Len(oIM:hosts[i,IM_BROWSE]:dataSource) .AND. ;
           n > 0 .AND. oIM:hosts[i,IM_USERLIST,n,USER_ONLINE],'Yes','No')}

* ----------------

STATIC FUNCTION ColorBlock( oIM, i, lTagMode )

RETURN {|n|_RowColor( oIM:hosts[i,IM_BROWSE], oIM:hosts[i,IM_USERLIST] )}

* ----------------

STATIC FUNCTION _RowColor( oBrowse, aUsers )

LOCAL nElement := oBrowse:arrayElement

IF nElement <= Len( oBrowse:dataSource ) .AND. nElement > 0
  IF aUsers[nElement,USER_TAG]
    RETURN { nil, GRA_CLR_YELLOW }
  ELSEIF aUsers[nElement,USER_ONLINE]
    RETURN { GRA_CLR_RED, GRA_CLR_WHITE }
  ENDIF
ENDIF

RETURN { nil, GRA_CLR_WHITE }

* ----------------

STATIC FUNCTION BrowseHideBlock( oIM, i )

RETURN {||!oIM:hosts[i,IM_CONNECTED] .OR. oIM:treeView}

* ----------------

STATIC FUNCTION TreeViewHideBlock( oIM, i )

RETURN {||!oIM:hosts[i,IM_CONNECTED] .OR. !oIM:treeView}

* ----------------

STATIC FUNCTION MemoHideBlock( oIM, i )

RETURN {||oIM:hosts[i,IM_CONNECTED]}

* ----------------

STATIC FUNCTION TabGotFocusBlock( oIm, i, GetList )

RETURN {||oIm:server := i, DC_GetRefresh(GetList)}

* ----------------

STATIC FUNCTION ButtonCaptionBlock( oIM, i )

RETURN {||IIF(oIM:hosts[i,IM_CONNECTED],'Disconnect','Connect')}

* ----------------

STATIC FUNCTION ButtonActionBlock( oIM, i )

RETURN {||IIF(oIM:hosts[i,IM_CONNECTED],oIM:hostDisconnect(i),oIM:hostConnect(i))}

* ----------------

STATIC FUNCTION userBrowseHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, oIM )

RETURN DCGUI_NONE

* ----------------

STATIC FUNCTION ArrayPointerBlock ( oIM, i )

RETURN {||oIM:hosts[i,IM_BROWSE]:arrayElement}


* ========================

CLASS IMConnection

EXPORTED:

VAR localUser
VAR localUserAlias
VAR localUserPassword
VAR localUserLastName
VAR localUserFirstName
VAR localUserEmail
VAR remoteUsers
VAR remoteUsersLastName
VAR remoteUsersFirstName
VAR remoteUsersAlias
VAR remoteUsersEmail
VAR remoteUsersPhoto
VAR host
VAR port
VAR fgColor
VAR bgColor
VAR font
VAR conversationNumber     // Conversation number
VAR conversationObject     // Conversation object (Web Browser) - Output
VAR conversationHeader     // Conversation Header (HTML)
VAR conversationText       // Conversation Text   (HTML)
VAR conversationFooter     // Conversation Footer (HTML)
VAR messageObject          // Message Window Object (Multiline) - Input
VAR messageBox             // Message object in bottom status line
VAR progress               // Progress bar object in bottom status line
VAR im
VAR lastMessageUser        // Last user that posted something in conversation window
VAR waveFile
VAR waveFileAttach
VAR dialogWindow
VAR messageSendButton
VAR startURL
VAR getList
VAR isRecording
VAR status
VAR startHtml
VAR server
VAR hasDisplayFocus
VAR soapAgent
VAR sessionId

METHOD Init
METHOD SendMessage
METHOD MessageWindow
METHOD SaveConversation
METHOD PrintConversation
METHOD SendFile
METHOD GetLocalFileName
METHOD Ring
METHOD Nudge
METHOD SendEmail
METHOD InviteToConference
METHOD beforeNavigate
METHOD HotButtonText
METHOD statusTextChange
METHOD createWebBrowser
METHOD addRemoteUser
METHOD createAudioFile
METHOD sendVoiceClip
METHOD recordButton
METHOD getHostTempFileName
METHOD handleDragDrop

ENDCLASS

* -------------

METHOD IMConnection:Init( oIM, nServer )

IF Valtype(oIM) == 'O'

  DEFAULT nServer := oIM:server
  ::server := nServer
  ::remoteUsers := oIM:hosts[nServer,IM_REMOTEUSERS]
  ::remoteUsersLastName := Array(Len(::remoteUsers))
  ::remoteUsersFirstName := Array(Len(::remoteUsers))
  ::remoteUsersAlias := Array(Len(::remoteUsers))
  ::remoteUsersEmail := Array(Len(::remoteUsers))
  ::remoteUsersPhoto := Array(Len(::remoteUsers))
  ::localUser := oIM:hosts[nServer,IM_LOCALUSER_ID]
  ::localUserAlias := oIM:hosts[nServer,IM_LOCALUSER_ALIAS]
  ::localUserPassword := oIM:hosts[nServer,IM_LOCALUSER_PASSWORD]
  ::localUserEmail := oIM:hosts[nServer,IM_LOCALUSER_EMAIL]
  ::localUserLastName := oIM:lastName
  ::localUserFirstName := oIM:firstName
  ::host := oIM:hosts[nServer,IM_HOST_NAME]
  ::port := oIM:hosts[nServer,IM_HOST_PORT]
  ::im := oIM
  ::conversationNumber := 0
  ::conversationHeader := MemoRead(DC_Path(AppName(.t.)) + '\IMCLIENT.CSS')
  ::conversationText := ''
  ::conversationFooter := '<div id="bottom"></div></body>'
  ::lastMessageUser := ''
  ::startURL := oIM:hosts[nServer,IM_STARTURL]
  ::isRecording := .f.
  ::status := 0
  ::hasDisplayFocus := .f.
  ::soapAgent := xbSOAPEnvelope():new()
  ::soapAgent:KeepAlive(.t.)

ENDIF

RETURN self

* -------------

METHOD IMConnection:MessageWindow( lSender )

LOCAL GetList[0], GetOptions, oMenuBar, oConversationMenu, oEditMenu, oViewMenu, ;
      oActionsMenu, oHelpMenu, cMessage :='', cConversation := '', ;
      cStatusMessage, oStatBot, cStartHtml, nDisplayMode, ;
      i, nFGColor, nBGColor, cFont, cTitle, ;
      cAliasList := '', oToolBar1, oToolbar2, oStatTop1, oStatTop2, ;
      nTimeOut := 0, cCaption, cText, oDialog, oDlgArea, cLanguage, ;
      lTypingSent := .f., aPhoto, cPhoto, oStatRight, nRow, ;
      oPhotoPanel, aStatics, bRecord, oToolBar3, ;
      nRecordHotKey, aUserList, nFound

DEFAULT lSender := .T.

::getList := GetList

aUserList := ::im:hosts[::server,IM_BROWSE]:dataSource

ASize(::remoteUsersLastName,Len(::remoteUsers))
ASize(::remoteUsersFirstName,Len(::remoteUsers))
ASize(::remoteUsersAlias,Len(::remoteUsers))
ASize(::remoteUsersEmail,Len(::remoteUsers))
ASize(::remoteUsersPhoto,Len(::remoteUsers))

FOR i := 1 TO Len(::remoteUsers)

  nFound := AScan(aUserList,{|a|a[USER_ID]==::remoteUsers[i]})
  ::remoteUsersLastName[i] := aUserList[nFound,USER_LAST]
  ::remoteUsersFirstName[i] := aUserList[nFound,USER_FIRST]
  ::remoteUsersAlias[i] := aUserList[nFound,USER_ALIAS]
  ::remoteUsersEmail[i] := aUserList[nFound,USER_EMAIL]
  ::remoteUsersPhoto[i] := aUserList[nFound,USER_ID] + '.JPG'

  cAliasList += aUserList[nFound,USER_ALIAS] + ;
                IIF(i<Len(::remoteUsers),',','')

NEXT

IF ::im:displayMode == 3 // Text Window
  cStartHtml := 'I eXpress myself, therefore IM!!'
ELSE
  cStartHtml := ::conversationHeader + ;
    '<IM:welcome>I eXpress myself, therefore IM!!</IM:welcome>'
ENDIF

cTitle := 'IM Server ['  + ::im:hosts[::server,IM_HOST_ALIAS] + ;
          ']  (' + ::localUserAlias + ') to ('
IF Len(::remoteUsers) == 1
  cTitle += ::remoteUsersAlias[1] + ')'
ELSE
  cTitle += cAliasList + ')'
ENDIF

IF !Empty(::im:messageWindowHotButtons)

  DCSTATUSBAR oStatTop1 ALIGN DCGUI_ALIGN_TOP HEIGHT 30

  @ 0,0 DCTOOLBAR oToolBar1 SIZE 100, 30 PARENT oStatTop1 PIXEL BUTTONSIZE 40, 30 ;
        TYPE XBPSTATIC_TYPE_RAISEDBOX

  FOR i := 1 TO Len(::im:messageWindowHotButtons)

    cCaption := Substr(::im:messageWindowHotButtons[i],1,At('|',::im:messageWindowHotButtons[i])-1)
    cText := Substr(::im:messageWindowHotButtons[i],At('|',::im:messageWindowHotButtons[i])+1)

    IF Empty(cCaption) .OR. Empty(cText)
      LOOP
    ENDIF

    DCADDBUTTON ;
      CAPTION 'F' + Alltrim(Str(i)) + ';' + cCaption ;
      PARENT oToolBar1  ;
      ACCELKEY xbeK_F1 + (i-1) ;
      CARGO cText ;
      TOOLTIP cText ;
      ACTION {|a,b,o|::hotButtonText(o)} ;
      ALIGNCAPTION BS_MULTILINE

  NEXT

ENDIF

IF ::im:enableFileTransfer .OR. ::im:enableEmail .OR. !Empty(::im:sendFileButtons)

  DCSTATUSBAR oStatTop2 ALIGN DCGUI_ALIGN_TOP HEIGHT 30

  @ 0,0 DCTOOLBAR oToolBar2 SIZE 80, 30 PARENT oStatTop2 PIXEL BUTTONSIZE 80, 30 ;
        TYPE XBPSTATIC_TYPE_RAISEDBOX

  IF ::im:enableFileTransfer
    DCADDBUTTON CAPTION 'Send File' PARENT oToolBar2 ;
       ACTION {||::sendFile()}
  ENDIF

  IF ::im:enableEmail
    DCADDBUTTON CAPTION 'Send E-Mail' PARENT oToolBar2 ;
       ACTION {||::sendEmail()}
  ENDIF

  IF !Empty(::im:sendFileButtons)

    FOR i := 1 TO Len(::im:sendFileButtons)

      cCaption := Substr(::im:sendFileButtons[i],1,At('|',::im:sendFileButtons[i])-1)
      cText := Substr(::im:sendFileButtons[i],At('|',::im:sendFileButtons[i])+1)

      IF Empty(cCaption) .OR. Empty(cText)
        LOOP
      ENDIF

      DCADDBUTTON ;
        CAPTION cCaption ;
        PARENT oToolBar2  ;
        CARGO cText ;
        TOOLTIP 'Send File: ' + cText ;
        ACTION {|a,b,o|::sendFile(o)} ;
        ALIGNCAPTION BS_MULTILINE

    NEXT

  ENDIF

ENDIF

DCSTATUSBAR oStatRight ALIGN DCGUI_ALIGN_RIGHT WIDTH 100

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 100,1000 ;
      OBJECT oPhotoPanel PARENT oStatRight ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE PIXEL ;
      FONT '8.Arial'

aStatics := Array(Len(::remoteUsers)+1)

nRow := 10
FOR i := 1 TO Len(::remoteUsers)

  @ nRow, 10 DCSAY ::remoteUsersAlias[i] FONT '10.Courier New Bold' PIXEL ;
    PARENT oPhotoPanel SAYSIZE 0

  cPhoto := DC_Path(AppName(.t.)) + 'Photos\' + ::remoteUsers[i] + '.JPG'
  nRow += 20
  @ nRow,0 DCSAY ';;Photo;not;Available' ;
          SIZE 100,100 ;
          TOOLTIP 'Photo File: ' + cPhoto + ';;' + ;
                  'Click here to download from IM Server' ;
          CARGO { ::remoteUsers[i], ::remoteUsersAlias[i] } ;
          HYPERLINK {|a,b,o|::im:getPhoto(::server,o)};
          CURSOR POINTER_HAND_M ;
          SAYOPTION XBPSTATIC_TEXT_WORDBREAK + ;
                    XBPSTATIC_TEXT_CENTER ;
          COLOR GRA_CLR_WHITE, GRA_CLR_DARKGRAY ;
          PARENT oPhotoPanel PIXEL ;
          OBJECT aStatics[i]

  IF File(cPhoto)
    DCBITMAP cPhoto PARENT aStatics[i] AUTOSCALE CENTER
  ENDIF

  nRow += 110

NEXT

nRow += 20

@ nRow, 10 DCSAY ::localUserAlias FONT '10.Courier New Bold' PIXEL ;
     PARENT oPhotoPanel SAYSIZE 0

nRow += 20
cPhoto := DC_Path(AppName(.t.)) + 'Photos\' + ::localUser + '.JPG'

@ nRow,0 DCSAY ';;Photo;not;Available' ;
         TOOLTIP 'Photo File: ' + cPhoto + ';;' + ;
                 'Click here to choose a Photo file and send to IM Server' ;
         HYPERLINK {|a,b,o|::setPhoto(::server,self)};
         CURSOR POINTER_HAND_M ;
         SIZE 100,100 ;
         SAYOPTION XBPSTATIC_TEXT_WORDBREAK + ;
                   XBPSTATIC_TEXT_CENTER ;
         COLOR GRA_CLR_WHITE, GRA_CLR_DARKGRAY ;
         PARENT oPhotoPanel PIXEL ;
         OBJECT aStatics[i]

IF File(cPhoto)
  DCBITMAP cPhoto PARENT aStatics[i] AUTOSCALE CENTER
ENDIF

DCSTATUSBAR oStatBot ALIGN DCGUI_ALIGN_BOTTOM HEIGHT 20

@ 0,0 DCSAY '' SAYSIZE 200,20 PIXEL COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '10.Lucida Console' OBJECT ::messageBox PARENT oStatBot

@ 0,1 DCPROGRESS ::progress SIZE 150,16 PIXEL ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_CYAN, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC ;
      PARENT oStatBot

DCMENUBAR oMenuBar OWNERDRAW

  DCSUBMENU oConversationMenu PROMPT 'Conversation' PARENT oMenuBar
    DCMENUITEM 'New' PARENT oConversationMenu
    DCMENUITEM SEPARATOR PARENT oConversationMenu
    DCMENUITEM 'Send' PARENT oConversationMenu ;
       ACTION {||PostAppEvent(xbeP_Activate,,,::messageSendButton)} ;
       WHEN {||!Empty(::messageObject:editBuffer())}
    DCMENUITEM SEPARATOR PARENT oConversationMenu
    DCMENUITEM 'Save As' PARENT oConversationMenu ;
       ACTION {||::SaveConversation(cConversation)}
    DCMENUITEM 'Print' PARENT oConversationMenu ;
       ACTION {||::PrintConversation(cConversation)}
    DCMENUITEM SEPARATOR PARENT oConversationMenu
    DCMENUITEM 'Close' PARENT oConversationMenu ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

  DCSUBMENU oEditMenu PROMPT 'Edit' PARENT oMenuBar
    DCMENUITEM 'Undo' PARENT oEditMenu
    DCMENUITEM SEPARATOR PARENT oEditMenu
    DCMENUITEM 'Cut' PARENT oEditMenu
    DCMENUITEM 'Copy' PARENT oEditMenu
    DCMENUITEM 'Paste' PARENT oEditMenu
    DCMENUITEM SEPARATOR PARENT oEditMenu
    DCMENUITEM 'Delete' PARENT oEditMenu
    DCMENUITEM 'Select All' PARENT oEditMenu
    DCMENUITEM SEPARATOR PARENT oEditMenu
    DCMENUITEM 'Previous Message' PARENT oEditMenu
    DCMENUITEM 'Next Message' PARENT oEditMenu

  DCSUBMENU oViewMenu PROMPT 'View' PARENT oMenuBar

  DCSUBMENU oActionsMenu PROMPT 'Actions' PARENT oMenuBar
    IF ::im:enableEmail
      DCMENUITEM 'Send an Email' PARENT oActionsMenu ;
        ACTION {||::sendEmail()}
    ENDIF
    DCMENUITEM 'Send Message to Group' PARENT oActionsMenu ;
      ACTION {||::im:sendGroupMessageWindow()}
    DCMENUITEM SEPARATOR PARENT oActionsMenu
    DCMENUITEM 'Ring' PARENT oActionsMenu ;
      ACTION {||::ring()}
    DCMENUITEM 'Nudge' PARENT oActionsMenu ;
      ACTION {||::nudge()}
    DCMENUITEM SEPARATOR PARENT oActionsMenu
    DCMENUITEM 'Send Audible' PARENT oActionsMenu ;
      ACTION {||Audible(self)}
    DCMENUITEM 'Attach Audible' PARENT oActionsMenu ;
      ACTION {||::waveFileAttach := Audible(self,,,,,.t.), ;
                ::messageBox:setCaption('Attached Audible: ' + ;
                IIF(Empty(::waveFileAttach),"None", ;
                Strtran(Strtran(::waveFileAttach,'_',' '),'.Wav','')))}
    DCMENUITEM SEPARATOR PARENT oActionsMenu
    DCMENUITEM 'Invite User to Conference' PARENT oActionsMenu ;
      ACTION {||::inviteToConference()} ;
      WHEN {||lSender}

  DCSUBMENU oHelpMenu PROMPT 'Help' PARENT oMenuBar
    DCMENUITEM 'Display Help Page' PARENT oHelpMenu ;
      ACTION {||RunExplorerHelp(self)}
    DCMENUITEM 'About IM Client' PARENT oHelpMenu ;
      ACTION {||AboutIM()}

IF ::im:displayMode = 3

  @ 0,0 DCMULTILINE cStartHtml ;
      SIZE 80,19 ;
      OBJECT ::conversationObject ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;

ELSE

  @ 0,0 DCHTMLVIEWER ::conversationObject ;
      SIZE 80,19 ;
      NAVIGATE ::startURL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      STATUSTEXTCHANGE {|c|::statusTextChange(c)} ;
      BEFORENAVIGATE {|a,b,c|::beforeNavigate(a,b,c)}

ENDIF

@ 19, 0 DCTOOLBAR oToolBar3 SIZE 70, 1 TYPE XBPSTATIC_TYPE_TEXT ;
        BUTTONSIZE 7,1

bRecord := {|n|::recordButton(n)}

DCADDBUTTON CAPTION {||IIF(::isRecording,'Stop','Record')} PARENT oToolBar3 ;
      TOOLTIP 'Click this button to start recording a Voice Clip,;' + ;
              'Click again to stop recording and send the Voice Clip.;' + ;
              ' -or-;' + ;
              'Press and hold ' + ::im:recordKeyString + ;
              ' key to start recording;' + ;
              'Release key to stop recording and send the Voice Clip.' ;
      ID 'RECORD_BUTTON' ;
      ACTION bRecord

DCHOTKEY ::im:recordKey ACTION {||Eval(bRecord,::im:recordKey)} ;
      WHEN {||!::isRecording}

@ 20, 0 DCMULTILINE cMessage SIZE 70, 3 ;
      FONT '8.Lucida Console' ;
      OBJECT ::messageObject ;
      ID 'MESSAGE_OBJECT' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X ;
      NOHSCROLL ;
      GOTFOCUS {||lTypingSent := .f.} ;
      EVAL {|o|o:keyboard := ;
          {|n|DC_GetRefresh(GetList,'SEND_BUTTON'), ;
              _CheckForSend(n,::messageSendButton,self,@lTypingSent,::im:sendKey)}}

@ 20, 72 DCPUSHBUTTON CAPTION 'Send' SIZE 7,2 ;
      WHEN {||!Empty(::messageObject:editBuffer())} ;
      OBJECT ::messageSendButton ;
      TOOLTIP 'Click here or press ' + ::im:sendKeyString + ' to send' ;
      ID 'SEND_BUTTON' ;
      RESIZE DCGUI_RESIZE_REPOSONLY_X ;
      ACTION {||::sendMessage(), SetAppFocus(::messageObject)}

DCGETOPTIONS ;
   RESIZE ;
   FITPAD 2 ;
   ALWAYSONTOP ;
   HIDE ;
   MESSAGEINTO {|c|::messageBox:setCaption(c)}

DCREAD GUI ;
   FIT ;
   HANDLER imConnectionHandler REFERENCE self ;
   SETAPPWINDOW ;
   SETFOCUS 'MESSAGE_OBJECT' ;
   NOAUTORESTORE ;
   OPTIONS GetOptions ;
   TITLE cTitle ;
   EVAL {|o|::im:push(self), ;
           ::im:hosts[::server,IM_MESSAGEWINDOW] := o, ;
           o:alwaysOnTop := .f., ;
           o:configure(), ;
           ::CreateWebBrowser( oDlgArea, cStartHtml ), ;
           nil, ;
           ::dialogWindow := o, ;
           o:show(), ;
           ::conversationObject:setParent():dropZone := .t., ;
           ::conversationObject:setParent():DragDrop := {|aState,oData| ::HandleDragDrop(aState,oData) }, ;
           DC_CompleteEvents(), ;
           IIF(!Empty(::startHtml),::setHtml(::startHtml),nil), ;
           SetAppFocus(::messageObject), ;
           ::status := 1 }
IF ::conversationObject:isderivedFrom("WebBrowser")
  ::conversationObject:disconnect()
ENDIF

::im:pop(self)
Sleep(5)

RETURN self

* ----------

METHOD IMConnection:handleDragDrop( aState, oData )

LOCAL aFileList, oZip, i, cFileName, lStatus := .f.

aFileList := oData:getData(XBPCLPBRD_FILELIST)

IF Len(aFileList) > 0
  DCMSGBOX 'ZIP up the dropped file list and send it to ' + ::remoteUsersAlias[1] + '?' ;
     YESNO TO lStatus
  IF lStatus
/*
    cFileName := TempFileName( '.\DOWNLOAD', '.ZIP' )
    oZip := XbZlibZip():new('.\DOWNLOAD\' + cFileName)
    FOR i := 1 TO Len(aFileList)
      oZip:addFile(aFileList[i])
    NEXT
    oZip:save()
    oZip:close()
    lStatus := ::sendFile( , '.\DOWNLOAD\' + cFileName )
*/
  DCMSGBOX 'This is not completed!'
  ENDIF
ENDIF

RETURN lStatus

* ----------

METHOD IMConnection:CreateWebBrowser()

LOCAL bErrorBlock

bErrorBlock := ErrorBlock({||TrapError()})
BEGIN SEQUENCE
::conversationObject:navigate(::startURL )
END SEQUENCE
ErrorBlock(bErrorBlock)
RETURN self

* ----------

METHOD IMConnection:recordButton( nHotKey )

::isRecording := !::isRecording
DC_GetRefresh(::getList,'RECORD_BUTTON')

IF ::isRecording
  Thread():new():start({||::CreateAudioFile(nil,nHotKey)})
ELSE
  Sleep(10)
  DC_GetRefresh(::getList,'RECORD_BUTTON')
ENDIF

RETURN nil

* --------------

METHOD imConnection:CreateAudioFile( cFileName, nHotKey, nFormat )

LOCAL oAudio, nSeconds := Seconds(), nCount, cRegSvr, cRegQuery, ;
      cWaveFile

DEFAULT nFormat := 0, ;  // .WAV
        cFileName := DC_Path(AppName(.t.)) + 'VoiceClip.Wav'

IF '98' $ Os()
  cRegSvr := 'c:\windows\system\regsvr32.exe'
ELSE
  cRegSvr := 'regsvr32.exe'
ENDIF

cRegQuery := DC_RegQuery(HKEY_CLASSES_ROOT,'\CLSID\{3387A365-D5A3-4BEE-8095-C5CFD9ABE517}','')
IF Valtype(cRegQuery) # 'C' .OR. Empty(cRegQuery)
  ::messageBox:setCaption('Registering Audio ActiveX Control...')
  RunShell(DC_Path(AppName(.t.))+ '..\runtime\audioctl.dll /s',cRegSvr)
  ::messageBox:setCaption('')
ENDIF

oAudio := ActiveXObject():create('AudioCtl.AudioRecord.1')
IF Valtype(oAudio) # 'O'
  DC_WinAlert('Could not register Audio ActiveX Control')
ENDIF

oAudio:setCode("3666CD1901900EF44DEB42")

oAudio:setOutputFilename(Alltrim(cFileName))
oAudio:fileFormat := nFormat

oAudio:startRecord( 2, 11025 )
::messageBox:setCaption('Recording...')
nCount := 0

DO WHILE ::isRecording .AND. Seconds() - nSeconds < RECORD_TIME_MAX
  IF Valtype(nHotKey) == 'N'
    DC_ClearEvents()
    IF !(AppKeyState(nHotKey)==1)
      EXIT
    ENDIF
  ENDIF
  Sleep(100)
  DC_GetProgress(::progress,nCount++,RECORD_TIME_MAX)
ENDDO

oAudio:stopRecord()
::messageBox:setCaption('')

::isRecording := .f.
DC_GetRefresh(::getList,'RECORD_BUTTON')
DC_GetProgress(::progress,0,RECORD_TIME_MAX)

cWaveFile := ::sendVoiceClip()

IF !Empty(cWaveFile)
  ::sendMessage(,,,DC_Path(cWaveFile,.t.),'<<voiceclip>>')
ENDIF

RETURN nil

* ----------

METHOD IMConnection:getHostTempFileName( cLocation, cExtension )

LOCAL oAgent, oResult, nStatus, cFileName := ''

oAgent := xbSOAPEnvelope():new()
oAgent:action := "GetHostTempFileName"
oAgent:setVar('UserID',::localUser)
oAgent:setVar('Password',::localUserPassword)
oAgent:setVar('Location',cLocation)
oAgent:setVar('Extension',cExtension)
oResult := oAgent:Execute( Trim(::host) + ":" + NTrim(::port), "GetHostTempFileName" )
nStatus := oResult:getVar('Status')
IF nStatus == 214
  cFileName := oResult:getVar('FileName')
ENDIF

RETURN cFileName

* ----------

METHOD IMConnection:sendVoiceClip()

LOCAL cLocalWaveFile := DC_Path(AppName(.t.)) + 'VoiceClip.Wav', ;
      cHostFileName, cBin

IF !File(cLocalWaveFile)
  RETURN nil
ENDIF

::im:putFile( ::server, nil, cLocalWaveFile,,@cHostFileName,'VoiceClips',.t.,'.WAV', ;
              ::messageBox, ::progress )

RETURN cHostFileName

* ----------

STATIC FUNCTION ImConnectionHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, oConn )

LOCAL cRemoteFile, cRemoteUser, cRemoteTempFile, cLocalFile, aTokens, cUrl, ;
      bErrorBlock, cWaveFile, cBin

IF nEvent == xbeP_User + USER_EVENT_GETFILE

  cUrl := Strtran(mp1,'http://download/','')
  aTokens := DC_TokenArray( cUrl, '/' )
  cRemoteFile := aTokens[1]
  cRemoteUser := aTokens[2]
  cRemoteTempFile := aTokens[3]
  // PostAppEvent( xbeP_User + USER_EVENT_GETFILE, aTokens,,  )
  cLocalFile := oConn:getLocalFileName(cRemoteFile,cRemoteUser)
  IF !Empty(cLocalFile)
    oConn:im:getFile( oConn:server, cRemoteFile, cLocalFile, cRemoteTempFile, .f.,,,, ;
                      oConn:messageBox, oConn:progress, oConn )
  ENDIF

ELSEIF nEvent == xbeP_User + USER_EVENT_VOICECLIP

  cWaveFile := Strtran(mp1,'http://voiceclip/','')
  PlayWave( cWaveFile, 'VoiceClips\' )

ELSEIF nEvent = xbeP_User + USER_EVENT_SETHTML

  bErrorBlock := ErrorBlock({||TrapError()})
  BEGIN SEQUENCE
  DO WHILE oConn:conversationObject:isBusy()
    Sleep(10)
  ENDDO
  oConn:conversationObject:setHtml( mp1 )
  IF !oConn:hasDisplayFocus
    cBin := FlashWInfo(oXbp:getHwnd())
    FlashWindowEx( @cBin )
  ENDIF
  END SEQUENCE
  ErrorBlock(bErrorBlock)

ELSEIF nEvent = xbeP_SetDisplayFocus .AND. oDlg == oConn:dialogWindow

  oConn:hasDisplayFocus := .t.

ELSEIF nEvent = xbeP_KillDisplayFocus .AND. oDlg == oConn:dialogWindow

  oConn:hasDisplayFocus := .f.

ENDIF

RETURN nil

* ----------

METHOD IMConnection:beforeNavigate( cUrl, cCgi, oBrowser )

IF 'http://download' $ cUrl
  PostAppEvent( xbeP_User + USER_EVENT_GETFILE, cUrl,,::dialogWindow  )
  RETURN .t.
ELSEIF 'http://voiceclip' $ cUrl
  PostAppEvent( xbeP_User + USER_EVENT_VOICECLIP, cUrl,,::dialogWindow  )
  RETURN .t.
ENDIF

RETURN .f.

* ----------

METHOD IMConnection:statusTextChange( cText )

IF Upper(cText) = 'DONE' .OR. Upper(cText) = 'OPENING' .OR. Upper(cText) = 'WAITING'
  cText := ''
ENDIF

::messageBox:setCaption(cText)

RETURN self

* ----------

METHOD IMConnection:hotButtonText(oButton)

LOCAL lSend := .f., cText := DC_GetCargo(oButton), cWaveFile, aTokens

IF !Empty(cText)
  aTokens := DC_TokenArray(cText,'|')
  ASize(aTokens,2)
  cText := aTokens[1]
  cWaveFile := aTokens[2]
  IF '^' $ cText
    lSend := .t.
    cText := Strtran(cText,'^','')
  ENDIF
  ::messageObject:setData(cText)
  ::messageSendButton:enable()
  ::waveFile := cWaveFile
  IF lSend
    PostAppEvent(xbeP_Activate,,,::messageSendButton)
  ENDIF
ENDIF

RETURN self

* ----------

METHOD IMConnection:ring()

RETURN ::sendMessage(,,,'RING.WAV')

* ----------

METHOD IMConnection:nudge()

RETURN ::sendMessage(,,,'NUDGE.WAV','<<nudge>>')

* ----------

METHOD IMConnection:sendMessage( cRemoteFile, cLocalFile, aRemoteUsers, ;
                                 cWaveFile, cMessage, oStatus, lActiveOnly )

LOCAL oAgent := xbSOAPEnvelope():new(), oResult, nStatus, ;
      cConversation, cStatusMessage, cHeader, nConversationNum, ;
      lFileSent := .F., cUserName, i, aActive, cRemoteTempFile, ;
      cUser, aTokens, bErrorBlock, cServerTime, dServerDate, ;
      aSoapVars, cSoapAction

IF Empty(aRemoteUsers)
  aRemoteUsers := ::remoteUsers
ENDIF

IF !Empty(cRemoteFile) .AND. !Empty(cLocalFile)
  IF Len(aRemoteUsers) == 1
    cUserName := aRemoteUsers[1]
  ELSE
    cUserName := 'DOWNLOAD'
  ENDIF


  lFileSent := ::im:putFile( ::server, cRemoteFile, cLocalFile, cUserName, @cRemoteTempFile,,,, ;
                             ::messageBox, ::progress )

  cMessage := ::localUserAlias + ' has sent you a file<br>' + ;
              '<a href = http://download\' + cRemoteFile + '/' + cUserName + '/' + cRemoteTempFile + ;
              '>Click here to download</a>'

ELSEIF !Empty(cWaveFile)
ELSEIF !Empty(cMessage)
ELSEIF Empty(cMessage := ::messageObject:editBuffer())
  RETURN .f.
ENDIF
::soapAgent := xbSOAPEnvelope():new()
::soapAgent:action := "SendMessage"
::soapAgent:setVar('ToUserList',aRemoteUsers)
::soapAgent:setVar('FromUser',Alltrim(::localUser))
::soapAgent:setVar('Password',Alltrim(::localUserPassword))
::soapAgent:setVar('Message',cMessage)
::soapAgent:setVar('FGColor',::fGColor)
::soapAgent:setVar('BGColor',::bGColor)
::soapAgent:setVar('Font',::font)
::soapAgent:setVar('FileName',cRemoteFile)
::soapAgent:setVar('TempFileName',cRemoteTempFile)
::soapAgent:setVar('ConversationNum',::conversationNumber)
::soapAgent:setVar('ActiveOnly',lActiveOnly)

IF !Empty(cWaveFile)
  ::soapAgent:setVar('WaveFile',cWaveFile)
ELSEIF !Empty(::waveFile)
  ::soapAgent:setVar('WaveFile',::waveFile)
  ::waveFile := nil
ELSE
  ::soapAgent:setVar('WaveFile',::waveFileAttach)
ENDIF

oResult := ::soapAgent:Execute( Trim(::host) + ":" + NTrim(::port), "SendMessage" )

IF !Empty(cLocalFile)
  cMessage := 'File: ' + cLocalFile + ' has been uploaded to the server.' + ;
              '  Notification will be sent after ' + ;
              'file is downloaded from the server.'
ENDIF

nStatus := oResult:getVar('Status')
cStatusMessage := oResult:getVar('StatusMessage')
nConversationNum := oResult:getVar('ConversationNum')
aActive := oResult:getVar('ActiveArray')
cServerTime := oResult:getVar('ServerTime')
dServerDate := oResult:getVar('ServerDate')

IF Valtype(nConversationNum) == 'N'
  ::conversationNumber := nConversationNum
ENDIF

IF Valtype(oStatus) # 'O'
  oStatus := ::messageBox
ENDIF

IF nStatus == NIL
  oStatus:setCaption('(100) Server not responding at ' + ;
               Trim(::host) + ' Port: ' + Alltrim(Str(::port)))
ELSEIF nStatus >= 900
  oStatus:setCaption('Server Error!!!')
  DC_GuiMemoEdit(cStatusMessage)
ELSEIF nStatus # 207
  oStatus:setCaption( cStatusMessage )
ELSEIF !Empty(cMessage) .AND. !cMessage $ {'<<typing>>','<<nudge>>','<<voiceclip>>'}
  IF Left(cMessage,10) == '<<invite>>'
    aTokens := DC_TokenArray(cMessage,',')
    cMessage := '<b>' + aTokens[2] + ' has been invited to the conference.</b>'
  ENDIF
  IF Valtype(::conversationObject) == 'O'
    IF ::im:displayMode == 1 // MSN
      IF ::lastMessageUser == ::localUser
        cHeader := '<IM:local><table width=100%><tr><th align=left>...</th><td align=right>' + ;
                   Time()+'</td></tr></table></IM:local>'
      ELSE
        cHeader := '<IM:local><table width=100%><tr><th align=left>' + ::localUserFirstName + ' ' + ;
                   ::localUserLastName + ;
                   ' says:</th><td align=right>' + cServerTime + '</td></tr></table></IM:local>'
      ENDIF
    ELSEIF ::im:displayMode == 2 // Yahoo
      cHeader := '<IM:localYahoo>' + ::localUserFirstName + ' ' + ;
                 ::localUserLastName + ' : </IM:localYahoo>'
    ELSEIF ::im:displayMode == 3 // Text Window
      ::conversationText += ( ::localUserAlias + ': ' + cMessage )
    ENDIF

    IF ::im:displayMode == 3 // Text Window
      ::conversationObject:setData(::conversationText)
      ::conversationObject:setFirstChar(Len(::conversationObject:editBuffer()))
    ELSE
      ::conversationText += cHeader + cMessage + '<br>'

      PostAppEvent( xbeP_User + USER_EVENT_SETHTML, ;
                    ::conversationHeader + ;
                    ::conversationText + ;
                    ::conversationFooter, nil, ::dialogWindow )

    ENDIF

    ::lastMessageUser := ::localUser
    IF !lFileSent
      oStatus:setCaption('')
    ENDIF
  ENDIF

  cMessage := ''

  IF Valtype(aActive) == 'A'
    FOR i := 1 TO Len(aActive)
      IF !aActive[i]
        cMessage += '<IM:inactive>' + ::remoteUsers[i] + ' appears to be off-line.</IM:inactive><br>'
      ENDIF
    NEXT
  ENDIF
  IF !Empty(cMessage) .AND. Valtype(::conversationObject) == 'O'
    ::conversationText += cMessage
    IF ::im:displayMode == 3
      ::conversationOject:setData( ::conversationText )
      ::conversationObject:setFirstChar(Len(::conversationObject:editBuffer()))
    ELSE
      PostAppEvent( xbeP_User + USER_EVENT_SETHTML, ;
                    ::conversationHeader + ;
                    ::conversationText + ;
                    ::conversationFooter, nil, ::dialogWindow )
    ENDIF
  ENDIF

  IF Valtype(::messageObject) == 'O'
    ::messageObject:setData('')
  ELSE
    oStatus:setCaption('Message sent!')
  ENDIF
  IF cMessage == '<<voiceclip>>'
    ::messageBox:setCaption('Voice Clip sent!!')
  ENDIF

ENDIF

::soapAgent:destroy()
::soapAgent :=nil

Sleep(10)

RETURN self

* ----------

METHOD IMConnection:saveConversation()
RETURN nil

* ----------

METHOD IMConnection:printConversation()

DC_WinAlert('Not completed. Right click mouse in window and select PRINT from menu')
// ::conversationObject:xbpActiveXControl:Print()

RETURN nil

* ----------

METHOD IMConnection:sendFile( oButton, cLocalFile )

IF !Empty(cLocalFile)
ELSEIF Valtype(oButton) == 'O'
  cLocalFile := DC_GetCargo(oButton)
ELSE
  cLocalFile := DC_PopFile()
ENDIF

IF Empty(cLocalFile) .OR. Left(cLocalFile,1) == '*'
  RETURN nil
ENDIF

IF !Empty(cLocalFile)
  IF !File(cLocalFile)
    ::messageBox:setCaption('File not found: ' + cLocalFile)
  ELSE
    ::sendMessage( DC_Path(cLocalFile,.t.), cLocalFile, nil )
  ENDIF
ENDIF

RETURN nil

* ----------

METHOD IMConnection:sendEMail( lBroadCast )

LOCAL cEmail

IF Len(::remoteUsersEmail) == 1
  cEmail := ::remoteUsersEmail[1]
  DC_SendMailToDefault( cEmail )
ENDIF

RETURN nil

* ----------

METHOD IMConnection:inviteToConference()

LOCAL oAgentUsers := xbSOAPEnvelope():new(), aUsers, oBrowse, nStatus, ;
      i, oResult, nPointer := 1, GetList[0], GetOptions, lStatus, aUser, ;
      cUsers

oAgentUsers:action := "GetUsers"
oAgentUsers:setVar('UserID',Alltrim(::localUser))
oAgentUsers:setVar('Password',Alltrim(::localUserPassword))
oAgentUsers:setVar('LoggedOnOnly',.t.)
oAgentUsers:keepAlive(.t.)
oResult := oAgentUsers:Execute( Trim(::host) + ":" + NTrim(::port), "GetUsers" )
nStatus := oResult:getVar('Status')
IF Empty(nStatus)
  DC_WinAlert('IM Server Not Available!')
  RETURN nil
ENDIF
IF nStatus == 200
  aUsers := oResult:getVar("UserList")
ENDIF

IF Valtype(aUsers) == 'A'
  FOR i := 1 TO Len(aUsers)
    IF aUsers[i,1] == Upper(::localUser) .OR. aUsers[i,USER_ID] $ ::remoteUsers
      ARemove( aUsers, i )
      i := 0
    ENDIF
  NEXT
ENDIF

IF Empty(aUsers)
  DC_WinAlert( 'No Users Available!' )
  RETURN nil
ENDIF

@ 0,0 DCBROWSE oBrowse DATA aUsers SIZE 40,20 FIT ;
      PRESENTATION DC_BrowPres() ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      POINTER nPointer ;
      COLOR {||{GRA_CLR_RED,GRA_CLR_WHITE}}

DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'User ID' ;
       WIDTH 10

DCBROWSECOL DATA {||Alltrim(DC_GetColArray(USER_FIRST,oBrowse)) + ' ' + ;
                    Alltrim(DC_GetColArray(USER_LAST,oBrowse))} ;
       HEADER 'Name' WIDTH 8 PARENT oBrowse ;

DCBROWSECOL ELEMENT 4 PARENT oBrowse HEADER 'Alias' ;
       WIDTH 7

DCBROWSECOL ELEMENT 6 PARENT oBrowse HEADER 'Status' ;
       WIDTH 20

DCGETOPTIONS

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TO lStatus ;
   TITLE 'Invite User to Conference' ;
   MODAL ;
   OPTIONS GetOptions

IF lStatus
  aUser := aUsers[nPointer]
  cUsers := aUser[USER_FIRST] + ' ' + aUser[USER_LAST] + ',' + aUser[USER_ID] + ',' + ::localUser
  FOR i := 1 TO LEN(::remoteUsers)
    cUsers += ',' + ::remoteUsers[i]
  NEXT
  AAdd( ::remoteUsers, Upper(Alltrim(aUser[USER_ID])) )
  AAdd( ::remoteUsersLastName, aUser[USER_LAST] )
  AAdd( ::remoteUsersFirstName, aUser[USER_FIRST] )
  AAdd( ::remoteUsersAlias, aUser[USER_ALIAS] )
  AAdd( ::remoteUsersEmail, aUser[USER_EMAIL] )
  ::sendMessage( , , , , '<<invite>>,' + cUsers, ::messageBox )
  Sleep(100)
ENDIF

oAgentUsers:destroy()

RETURN nil

* ----------

METHOD IMConnection:addRemoteUser( cUserID )

LOCAL oAgentUsers := xbSOAPEnvelope():new(), aUsers, aUser, nStatus, ;
      oResult, nFound

oAgentUsers:action := "GetUsers"
oAgentUsers:setVar('UserID',Alltrim(::localUser))
oAgentUsers:setVar('Password',Alltrim(::localUserPassword))
oAgentUsers:setVar('LoggedOnOnly',.t.)
oResult := oAgentUsers:Execute( Trim(::host) + ":" + NTrim(::port), "GetUsers" )
nStatus := oResult:getVar('Status')
IF Empty(nStatus)
  DC_WinAlert('IM Server Not Available!')
  RETURN nil
ENDIF
IF nStatus == 200
  aUsers := oResult:getVar("UserList")
ENDIF

oAgentUsers:destroy()

IF Valtype(aUsers) == 'A'
  nFound := AScan( aUsers, {|a|Upper(a[USER_ID])==Upper(cUserID)} )
  IF nFound > 0
    aUser := aUsers[nFound]
    AAdd( ::remoteUsers, Upper(Alltrim(aUser[USER_ID])) )
    AAdd( ::remoteUsersLastName, aUser[USER_LAST] )
    AAdd( ::remoteUsersFirstName, aUser[USER_FIRST] )
    AAdd( ::remoteUsersAlias, aUser[USER_ALIAS] )
    AAdd( ::remoteUsersEmail, aUser[USER_EMAIL] )
  ENDIF
ENDIF

RETURN nil

* ----------

METHOD IMConnection:getLocalFileName( cLocalFile, cRemoteUser )

LOCAL GetList[0], GetOptions, lStatus

cLocalFile := Pad(DC_Path(AppName(.t.)) + 'DOWNLOAD\' + DC_Path(cLocalFile,.t.),50)

@ 2,0 DCSAY 'Local File Name' GET cLocalFile ;
            SAYSIZE 0 ;
            SAYBOTTOM ;
            POPUP {||DC_PopFile( cLocalFile,,,,,.t. )}

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   NORESIZE ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TO lStatus ;
   TITLE 'Receive a File' ;
   OPTIONS GetOptions ;
   MODAL ;
   SETAPPWINDOW ;
   EVAL {|o|o:toFront()}

IF lStatus
  RETURN Alltrim(cLocalFile)
ENDIF

RETURN ''

* ----------

FUNCTION Audible( oConn, cHost, nPort, cGroupName, oStatus, lAttach )

LOCAL GetList[0], GetOptions, oBrowse, cWaveFile, nPointer := 1, ;
      i, lStatus, aWaves := Directory(DC_Path(AppName(.t.)) + '\MEDIA\*.WAV')

DEFAULT lAttach := .f.

FOR i := 1 TO Len(aWaves)
  aWaves[i,2] := Strtran(aWaves[i,1],'_',' ')
  aWaves[i,2] := Strtran(aWaves[i,2],'.Wav','')
  aWaves[i,2] := Strtran(aWaves[i,2],'.wav','')
  aWaves[i,2] := Strtran(aWaves[i,2],'.WAV','')
NEXT

@ 0,0 DCBROWSE oBrowse DATA aWaves SIZE 10,20 FIT ;
      PRESENTATION DC_BrowPres() ;
      ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      POINTER nPointer ;
      NOSOFTTRACK

DCBROWSECOL ELEMENT 2 HEADER 'Sound File' WIDTH 20 PARENT oBrowse

DCGETOPTIONS ;
   AUTORESIZE ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   OPTIONS GetOptions ;
   TITLE 'Send Audible' ;
   MODAL ;
   TO lStatus

IF lStatus .AND. Len(aWaves) > 0
  cWaveFile := aWaves[nPointer,1]
  IF lAttach
    RETURN cWaveFile
  ENDIF
  IF oConn:isDerivedFrom('IMCONNECTION')
    oConn:sendMessage(,,,cWaveFile,,oStatus)
  ELSE
    oConn:sendMessageToGroup( cGroupName, cHost, nPort,, cWaveFile, oStatus )
  ENDIF
  Sleep(10)
ENDIF

RETURN ''

* ----------

STATIC FUNCTION TrapError()
BREAK
RETURN nil

* ----------------

STATIC FUNCTION Cascade( o )

LOCAL oDlg, aChildList := AppDeskTop():childList()

IF Len(aChildList) > 2
  oDlg := aChildList[Len(aChildList)-1]
  o:setPos({oDlg:currentPos()[1]+30, ;
            oDlg:currentPos()[2]-o:currentSize()[2]+oDlg:currentSize()[2]-30})
ENDIF

RETURN nil

* ----------------

STATIC FUNCTION RunExplorerHelp(oConn)

LOCAL cURL

IF oConn:isDerivedFrom('IMConnection')
  cUrl := Alltrim(oConn:host) + ':' + Alltrim(Str(oConn:port)) + '/imhelp.htm'
ELSE
  cUrl := Alltrim(oConn:hosts[oConn:server,IM_HOST_NAME]) + ':' + ;
          Alltrim(Str(oConn:hosts[oConn:server,IM_HOST_PORT])) + '/imhelp.htm'
ENDIF

IF FExists('C:\Program Files\Internet Explorer\IExplore.exe')
  Runshell( cURL, 'C:\Program Files\Internet Explorer\IExplore.exe', .T. )
ELSE
  DC_SpawnUrl( cURL )
ENDIF

RETURN nil

* ----------

STATIC FUNCTION _CheckForSend( nKey, oSendButton, oConn, lTypingSent, nSendKey )

IF nKey == nSendKey
  PostAppevent(xbeP_Activate,,,oSendButton)
  lTypingSent := .T.
ELSEIF Empty(oConn:conversationText)
  RETURN nil
/*
ELSEIF !lTypingSent
  Thread():new():start({||oConn:sendMessage( nil, nil, nil, nil, '<<typing>>' )})
  lTypingSent := .T.
*/
ENDIF

RETURN nil

* ----------------

STATIC FUNCTION CheckForShutDown()

LOCAL cShutDown := DC_Path(AppName(.t.)) + 'SHUTDOWN.TXT'

IF File(cShutDown)
  DCMSGBOX 'The IM client will be shut down in 10 seconds', ;
           'by request of the IM Server Administrator' ;
           TIMEOUT 10
  QUIT
ENDIF

RETURN nil

* ------------

FUNCTION PlayWave( cWaveFile, cPath )

#DEFINE SND_SYNC      0   // 0x0000   // (Default flag) Plays sound synchronously, all the way through.
#DEFINE SND_ASYNC     1   // 0x0001   // Plays sound asynchronously.
#DEFINE SND_LOOP      8   // 0x0008   // Continues playing the sound until the function is called again.
#DEFINE SND_NOSTOP    10  // 0x00010  // Doesn't stop the current sound.
#DEFINE SND_FILENAME  131072

LOCAL x

DEFAULT cPath := 'MEDIA\'

IF !Empty(cWaveFile)

  IF ! '\' $ cWaveFile
    cWaveFile := DC_Path(AppName(.t.)) + cPath + cWaveFile
  ENDIF

  x := DllCall("WINMM.DLL",32,"PlaySoundA",cWaveFile,0, ;
                SND_FILENAME + SND_LOOP + SND_NOSTOP + SND_ASYNC )

  Sleep(10)

ENDIF

RETURN nil

* -----------

FUNCTION TaskBarMenu(oIM,lShowUserWindow)

LOCAL GetList[0], oTaskBar, oMenu, aRef[2]

oTaskBar := TaskBarIcon():New( xbeP_User + 30 ):Create()
oTaskBar:AddIcon( 1, ICON_EXPRESS , "Instant Messenger" )

DCSUBMENU oMenu PROMPT 'Taskbar Menu' PARENT oTaskBar

  DCMENUITEM 'Show Window' PARENT oMenu ;
      ACTION {||oIM:userBrowse(.f.)}

  DCMENUITEM 'Exit' PARENT oMenu ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

DCREAD GUI PARENT oTaskBar ;
   EVAL {||aRef[1] := oMenu, ;
           aRef[2] := oTaskBar, ;
           IIF(lShowUserWindow,oIM:userBrowse(.f.),nil)} ;
   HANDLER taskBarHandler REFERENCE @aRef

oTaskBar:remAllIcons()
QUIT

RETURN nil

* -----------

STATIC FUNCTION taskBarHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, aRef )

LOCAL oMenu := aRef[1], oTaskBar := aRef[2]

IF nEvent = xbeP_User + 30
  IF mp1[2] = xbeM_RbUp
    oMenu:PopUp( oTaskBar, { mp1[3], mp1[4] } )
  ENDIF
ENDIF

RETURN DCGUI_NONE

* -----------------

STATIC FUNCTION _LoadRdds()

LOCAL i, aDbeList := DbeList(), cDbeList := '', cDbe := dbeSetDefault()

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
  DC_WinAlert( "Database-Engine CDXDBE not loaded" )
ENDIF

IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
  DC_WinAlert( "Database-Engine FOXDBE not loaded" )
ENDIF

IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
  DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
ENDIF

DbeSetDefault('FOXCDX')

RETURN .t.

* ---------------

DLLFUNCTION compress(@cOut, @nOut, @cIn, nIn) USING CDECL FROM ZLIB1.DLL
DLLFUNCTION compress2(@cOut, @nOut, @cIn, nIn, nLevel) USING CDECL FROM ZLIB1.DLL
DLLFUNCTION uncompress(@cOut, @nOut, @cIn, nIn) USING CDECL FROM ZLIB1.DLL

* -------------

STATIC FUNCTION Nudge( oDialog )

LOCAL i, aPos := oDialog:currentPos()

PlayWave('NUDGE.WAV')

FOR i := 1 TO 20
  IF i % 2 = 0
    oDialog:setPos({oDialog:currentPos()[1]+10,oDialog:currentPos()[2]+10})
  ELSE
    oDialog:setPos({oDialog:currentPos()[1]-10,oDialog:currentPos()[2]-10})
  ENDIF
  Sleep(5)
NEXT

oDialog:setPos(aPos)

RETURN nil

* --------------

DLLFUNCTION CreateDirectoryA( a, b ) USING STDCALL FROM KERNEL32.DLL

* ------------

FUNCTION IMSetup()

LOCAL GetList[0], GetOptions, cText, cRetypePassword, lStatus, ;
      cAlias, cLastName, cFirstName, cEmail, cHostName, nHostPort, ;
      oDlg, oAgent, oResult, nStatus, cStatusMessage, aRef1, aData1, ;
      aRef2, aData2, cIniFile, cSavepassword, cHostAlias, lUserVisible, ;
      cStartUrl, nRow, cUserId, cPassword

cIniFile := DC_Path(Appname(.t.)) + 'IMCLIENT.INI'

aRef1 := ;
        {'HostName', ;
         'HostPort', ;
         'HostAlias', ;
         'UserID', ;
         'UserPassword', ;
         'UserAlias', ;
         'UserEmail', ;
         'UserVisible', ;
         'StartURL', ;
         'ViewOnlineOnly', ;
         'AlwaysPromptForLogin'}

aData1 := ;
        { Space(100), ;
          80, ;
          Space(20), ;
          Space(USERID_LEN), ;
          Space(PASSWORD_LEN), ;
          Space(ALIAS_LEN), ;
          Space(50), ;
          .t., ;
          Space(100), ;
          .f., ;
          .f. }

DC_IniLoad( cIniFile, 'IM_HOST_1', aData1, aRef1 )

cHostName := Pad(aData1[1],100)
nHostPort := aData1[2]
cHostAlias := Pad(aData1[3],20)
cUserID := Pad(aData1[4],USERID_LEN)
cSavePassword := Pad(aData1[5],PASSWORD_LEN)
cAlias := Pad(aData1[6],ALIAS_LEN)
cEmail := Pad(aData1[7],50)
lUserVisible := aData1[8]
cStartUrl := Pad(aData1[9],100)

aRef2 := {'LastName', ;
          'FirstName', ;
          'TreeView', ;
          'UserFont'}

aData2 := { Pad('<undefined>',30), ;
            Pad('<undefined>',30), ;
            .t., ;
            1 }

DC_IniLoad( cIniFile, 'USER_WINDOW_PREFERENCES', aData2, aRef2 )

cLastName := Pad(aData2[1],30)
cFirstName := Pad(aData2[2],30)

TEXT INTO cText WRAP
Before you can use Instant Messenger, you must set up a
User Account on the IM Server.  A unique User ID must be
assigned.  You may also choose an Alias which will be
displayed in the message window in place of your
name when posting messages.

This setup screen is only for entering information into
the IM_HOST_1 entry of IMCLIENT.INI.  Use a text editor to
add more hosts or to edit existing hosts.
ENDTEXT

DO WHILE .t.

  cPassword := Pad(cSavePassword,20)
  cRetypePassword := Space(20)

  @ 0,10 DCSAY cText SAYWORDBREAK SIZE 60,7

  nRow := 7
  @ nRow++,0 DCSAY 'User ID' GET cUserID PICT '@!' ;
               VALID {||DC_ReadEmpty(cUserID)}

  @ nRow++,0 DCSAY 'Password' GET cPassword PASSWORD ;
               VALID {||DC_ReadEmpty(cPassword)}

  @ nRow++,0 DCSAY 'Retype Password' GET cRetypePassword PASSWORD ;
               VALID {||DC_ReadEmpty(cRetypePassword)}

  @ nRow++,0 DCSAY 'First Name' GET cFirstName ;
               VALID {||DC_ReadEmpty(cFirstName)}

  @ nRow++,0 DCSAY 'Last Name' GET cLastName ;
               VALID {||DC_ReadEmpty(cLastName)}

  @ nRow++,0 DCSAY 'Alias' GET cAlias

  @ nRow++,0 DCSAY 'Email' GET cEmail GETSIZE 50
  nRow++

  @ nRow++,0 DCSAY 'IM Host Name or IP' GET cHostName GETSIZE 50 ;
              VALID {||DC_ReadEmpty(cHostName)}

  @ nRow++,0 DCSAY 'IM Port' GET nHostPort PICTURE '99999' ;
              VALID {||DC_ReadEmpty(nHostPort)}

  @ nRow++,0 DCSAY 'IM Host Alias' GET cHostAlias ;
              VALID {||DC_ReadEmpty(cHostAlias)} ;
              TOOLTIP 'Enter a short name to identify the host.;' + ;
                      'Example: eXpress++'

  DCGETOPTIONS ;
    SAYWIDTH 100 ;
    EXITVALIDATE ;
    SAYRIGHTBOTTOM ;
    TABSTOP ;
    BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

  DCREAD GUI ;
    FIT ;
    TITLE 'IM Setup' ;
    MODAL ;
    SETAPPWINDOW ;
    OPTIONS GetOptions ;
    TO lStatus ;
    NODESTROY ;
    PARENT @oDlg ;
    ADDBUTTONS

  IF lStatus
    IF !Alltrim(cPassword) == Alltrim(cRetypePassword)
      DC_WinAlert('Passwords to not match!')
      oDlg:destroy()
      oDlg := nil
      LOOP
    ENDIF
    cStartUrl := Alltrim(cHostName) + ':' + Ntrim(nHostPort)
    aData1 := { Alltrim(cHostName), nHostPort , Alltrim(cHostAlias), ;
                Alltrim(cUserID), Alltrim(cPassword), Alltrim(cAlias), ;
                Alltrim(cEmail), lUserVisible, Alltrim(cStartUrl) }
    DC_IniSave( cIniFile, 'IM_HOST_1', aData1, aRef1 )

    aData2 := { Alltrim(cLastName), Alltrim(cFirstName) }
    DC_IniSave( cIniFile, 'USER_WINDOW_PREFERENCES', aData2, aRef2 )

    aRef1 := {'RunSetup'}
    aData1 := {.f.}
    DC_IniSave( cIniFile, 'IM_MISC', aData1, aRef1 )
  ENDIF
  oDlg:destroy()
  EXIT

ENDDO

RETURN lStatus

* ------------

FUNCTION IMGetUser( cUserID, cPassword )

LOCAL cPath := DC_Path(AppName(.t.))

cUserID := Upper(Alltrim(WinWhoAmI()))
cPassword := ''

RETURN nil

* -------------

#define EHS_ERRORLOG "XPPERROR"

#define EHS_CANCEL            "Cancel"
#define EHS_EXIT_WITH_LOG     "Exit with LOG file"
#define EHS_RETRY             "Retry"
#define EHS_IGNORE            "Ignore"
#define EHS_OS_ERROR          ";Operating system error : "
#define EHS_CALLED_FROM       "Called from"
#define EHS_XPP_ERROR_MESSAGE "Xbase++ Error Message"
#define EHS_ERROR             "Error "
#define EHS_WARNING           "Warning "
#define EHS_DESCRIPTION       ";Description : "
#define EHS_FILE              ";File : "
#define EHS_OPERATION         ";Operation : "
#define EHS_LOG_OPEN_FAILED   "Unable to open error log file"
#define EHS_ERROR_LOG_OF      "ERROR LOG of "
#define EHS_DATE              " Date:"
#define EHS_XPP_VERSION       "Xbase++ version     :"
#define EHS_OS_VERSION        "Operating system    :"
#define EHS_LOG_WRITTEN_TO(cFile) "Error log was written to the file "+ cFile

* ------------

STATIC FUNCTION IMErrorHandler( oError )

LOCAL i, cMessage, aOptions, nOption, nSeverity
LOCAL row, col, aWaitOn

   /* Check if error is handled automatically */
DO CASE

   /* Division by zero results in 0 */
CASE oError:genCode == XPP_ERR_ZERODIV
RETURN 0

   /* Zero divide by zero is also 0 and may occur
    * in operations like /, /=, % and %=
    */
CASE oError:genCode == XPP_ERR_NUMERR
   IF "/" $ oError:operation .OR. "%" $ oError:operation
      IF oError:args[1] = 0
         IF len(oError:args) = 1
            RETURN 0
         ELSEIF oError:args[2] = 0
            RETURN 0
         ENDIF
      ENDIF
   ENDIF

   /* Error opening a file on a network */
CASE oError:genCode == XPP_ERR_OPEN  .AND. ;
      oError:osCode  == 32            .AND. ;
      oError:canDefault
RETURN(.F.)

   /* No lock is set */
CASE oError:genCode == XPP_ERR_APPENDLOCK .AND. ;
      oError:canDefault
RETURN(.F.)

ENDCASE

   /* No default handling defined: create error message */
cMessage := ErrorMessage( oError )

   /* Array for selection */
aOptions := { EHS_CANCEL, EHS_EXIT_WITH_LOG }

IF oError:canRetry
   AAdd( aOptions, EHS_RETRY )
ENDIF

IF oError:canDefault
   AAdd( aOptions, EHS_IGNORE )
ENDIF

IF ! Empty( oError:osCode )
   cMessage += EHS_OS_ERROR + LTrim(Str(oError:osCode))
ENDIF

IF oError:canDefault .AND. oError:canRetry
   nOption := XBPMB_ABORTRETRYIGNORE
ELSEIF oError:canRetry
   nOption := XBPMB_RETRYCANCEL
ELSEIF oError:canDefault
   nOption := XBPMB_OKCANCEL
ELSE
   nOption := XBPMB_CANCEL
ENDIF

i := 1
DO WHILE ! Empty( ProcName(++i) )
   cMessage+= ";" + EHS_CALLED_FROM +" " + Trim( ProcName(i) )   + "(" + ;
      LTrim( Str( ProcLine(i) ) ) + ")"
ENDDO

i := 0
* select icon for ConfirmBox()

DO CASE
CASE oError:severity == XPP_ES_FATAL
   nSeverity := XBPMB_CRITICAL
CASE oError:severity == XPP_ES_ERROR
   nSeverity := XBPMB_CRITICAL
CASE oError:severity == XPP_ES_WARNING
   nSeverity := XBPMB_WARNING
OTHERWISE
   nSeverity := XBPMB_INFORMATION
ENDCASE

ErrorLog( oError, 2, oError:severity, cMessage )

// Log user off and close all files.

ErrorLevel(1)

RETURN .F.

* -------------

STATIC FUNCTION ErrorMessage( oError )

/* Check if this is an error or warning message */
LOCAL cMessage := ;
         IIf( oError:severity > XPP_ES_WARNING, ;
                          EHS_ERROR, EHS_WARNING )

/* Add name of subsystem or 'unkown subsytem' */
IF Valtype( oError:subSystem ) == "C"
  cMessage += oError:subSystem
ELSE
  cMessage += "????"
ENDIF

/* Add error code of subsystem */
IF Valtype( oError:subCode ) == "N"
  cMessage += "/"+ LTrim(Str(oError:subCode))
ELSE
  cMessage += "/????"
ENDIF

/* Optional: Add error description */
IF Valtype( oError:description ) == "C"
  cMessage += EHS_DESCRIPTION + ;
                   oError:description
ENDIF

/* Optional: Add name of the file which were the error occured */
IF ! Empty( oError:fileName )
  cMessage += EHS_FILE + oError:fileName
ENDIF

/* Optional: Add name of the operation which caused the error */
IF ! Empty( oError:operation )
  cMessage += EHS_OPERATION + oError:operation
ENDIF

/* Add Thread ID of the thread on which the error occured */
cMessage += ";Thread ID : " + ;
                LTrim(Str(oError:thread))

RETURN cMessage

* ---------------

STATIC PROCEDURE ErrorLog( oError, nStackStart, nSeverity, cMessage )

LOCAL i:=0, bError := ErrorBlock( {|e| Break(e)} )
LOCAL cErrorLog, oTrack, aErrorInfo
LOCAL cExtension:= "LOG"
LOCAL lPrint, lConsole, cAlternate, lAlternate, lExtra
LOCAL nArea, cDescription, GetList[0], cDump
LOCAL cErrorShort, cCallStack
LOCAL lStatus, GetOptions, cBody

* Save current printer related settings, turn printer off *

lPrint     := Set( _SET_PRINTER )
lConsole   := Set( _SET_CONSOLE )
cAlternate := Set( _SET_ALTFILE )
lAlternate := Set( _SET_ALTERNATE )
lExtra     := Set( _SET_EXTRA, .F. )

SET PRINTER OFF
SET CONSOLE ON

IF SetAppWindow() == NIL ;
     .OR. .NOT. SetAppWindow():isDerivedFrom( RootCrt() )
  SET CONSOLE OFF
ENDIF

* Trap errors that might occur while opening the ALTERNATE file */
DO WHILE .T.
   cErrorLog := 'TEMPERR' + "." + cExtension
   BEGIN SEQUENCE
     Set(_SET_ALTFILE, cErrorLog, .f.)
     Set(_SET_ALTERNATE, .t.)
   RECOVER
      * ALTERNATE file could not be opened:
      * try other filename
     cExtension := PadL(++i,3,"0")
     IF i > 999
        MsgBox( EHS_LOG_OPEN_FAILED )
        ErrorLevel(1)
        QUIT
     ENDIF
     LOOP
   END SEQUENCE
   EXIT
ENDDO

//------------------------------------------------------------------
// General application information.
//------------------------------------------------------------------
? Replicate( "=", 78 )
? EHS_ERROR_LOG_OF +'"'+ appName(.T.) +'"'+ EHS_DATE, DC_XtoC(date()), time()
? Replicate( "-", 78 )
? EHS_XPP_VERSION        , Version()+"."+Version(3)
? "eXPress++ version   :", DC_VersionExpress()+"."+DC_VersionExpress(3)
? "Current Directory   :", DC_CurPath()
?

//------------------------------------------------------------------
// Error object information.
//------------------------------------------------------------------
? Replicate( "-", 78 )
? "ERROR OBJECT:"
? Replicate( "-", 78 )
? "oError:args         :"
IF Valtype(oError:Args)=="A"
   AEval( oError:Args, ;
          {|x,y| Qout( Space(9),"-> VALTYPE:", y:=Valtype(x) )  , ;
                  IIf( y=="O", QQout( " CLASS:", x:className() ), ;
                               QQout( " VALUE:", Var2Char(x) ) ) } )
ELSE
   Qout( Space(10),"-> NIL" )
ENDIF

? "oError:canDefault   :" , oError:canDefault
? "oError:canRetry     :" , oError:canRetry
? "oError:canSubstitute:" , oError:canSubstitute
? "oError:cargo        :" , oError:cargo
? "oError:description  :" , oError:description
? "oError:filename     :" , oError:filename
? "oError:genCode      :" , oError:genCode
? "oError:operation    :" , oError:operation
? "oError:osCode       :" , oError:osCode
? "oError:severity     :" , oError:severity
? "oError:subCode      :" , oError:subCode
? "oError:subSystem    :" , oError:subSystem
? "oError:thread       :" , oError:thread
? "oError:tries        :" , oError:tries

//------------------------------------------------------------------
// Callstack dump.
//------------------------------------------------------------------
? Replicate( "-", 78 )
? "CALLSTACK:"
? Replicate( "-", 78 )

i := nStackStart
DO WHILE ! Empty( ProcName(++i) )
  cCallStack := Trim( ProcName(i) )   + "(" + ;
                LTrim( Str( ProcLine(i) ) ) + ")"

 ? EHS_CALLED_FROM, cCallStack

  IF Empty(cErrorShort)
    cErrorShort := oError:description + ' - ' + cCallStack
  ENDIF
ENDDO

SET ALTERNATE TO
SET ALTERNATE OFF

// Restore previous settings
Set( _SET_PRINTER,   lPrint)
Set( _SET_CONSOLE,   lConsole)
Set( _SET_ALTFILE,   cAlternate)
Set( _SET_ALTERNATE, lAlternate)
Set( _SET_EXTRA,     lExtra)

cDump := MemoRead(cErrorLog)
MemoWrit(EHS_ERRORLOG+'.LOG',MemoRead(EHS_ERRORLOG+'.LOG')+cDump)

cDescription := ''
@ 2,0 DCSAY 'Please tell us what you were doing when this Error occurred!' ;
   SAYSIZE 0

@ 3,0 DCMULTILINE cDescription ;
   FONT          "10.Courier" ;
   NOHORIZSCROLL ;
   SIZE          40,10

@ 3, 45 DCSAY cMessage SAYWORDBREAK SIZE 35,13

@ 15,10 DCPUSHBUTTON CAPTION "Break" SIZE 9,1.2 ;
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
        WHEN {||!(nSeverity==XPP_ES_FATAL)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION "Quit" SIZE 9,1.2 ;
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Print Error' SIZE 10,1.2 ;
      ACTION {||PrintErrorDump(cErrorLog)}

@ DCGUI_ROW, DCGUI_COL + 20 DCPUSHBUTTON CAPTION 'View Error' SIZE 10,1.2 ;
      ACTION {||ViewErrorDump(cErrorLog)}

DCGETOPTIONS ;
   COLOR GRA_CLR_YELLOW ;
   NORESIZE

DCREAD GUI ;
   FIT ;
   TO lStatus ;
   OPTIONS GetOptions ;
   MODAL ;
   TITLE 'IM Runtime Error'

cBody := cDescription + CRLF + cDump
ErrorBlock(bError)

DC_SendMailToDefault( 'rogerdonnay@donnay-software.com',, ;
                      'Error in IM Client', cBody )

IF lStatus
  Break()
ENDIF

QUIT

RETURN

* -------------

STATIC FUNCTION PrintErrorDump( cErrorLog )

DC_PrintFile(cErrorLog)

RETURN nil

* -------------

STATIC FUNCTION ViewErrorDump( cErrorLog )

DC_MemoEdit(MemoRead(cErrorLog))

RETURN nil

* -------------

STATIC FUNCTION AboutIM()

LOCAL GetList[0], GetOptions

@ 0,10 DCSAY 'eXpress++ IM Client' SAYSIZE 0 FONT '14.Arial Bold' ;
      COLOR GRA_CLR_RED

@ 2,0 DCSAY 'Version:' FONT '10.Arial'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY scClientVersion SAYSIZE 0 ;
      FONT '10.Arial' COLOR GRA_CLR_DARKGREEN

@ 4,0 DCSAY 'Author:' FONT '10.Arial'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Roger Donnay' SAYSIZE 0 ;
      FONT '10.Arial' COLOR GRA_CLR_DARKGREEN

@ 6,0 DCSAY 'Libraries:' FONT '10.Arial'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Xbase++ 1.9, eXpress++ 1.9, Xb2Net 3.0' SAYSIZE 0 ;
      FONT '10.Arial' COLOR GRA_CLR_DARKGREEN

@ 8,0 DCSAY 'Home Page:' FONT '10.Arial'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'http://donnay-software.com/im.htm' SAYSIZE 0 ;
      FONT '10.Arial' COLOR GRA_CLR_BLUE ;
      CURSOR POINTER_HAND_M ;
      HYPERLINK {||DC_SpawnUrl('http://donnay-software.com/im.htm')}

DCGETOPTIONS NORESIZE SAYWIDTH 90 SAYRIGHTBOTTOM ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER ;
   COLOR GRA_CLR_WHITE

DCREAD GUI ;
   FIT ;
   BUTTONS DCGUI_BUTTON_OK ;
   OPTIONS GetOptions ;
   TITLE 'About IM Client' ;
   MODAL

RETURN nil

* ------------

FUNCTION KeyString2Num( cKey )

LOCAL aKey, aDefine, nFound

DC_AppKeyDefine(nil,@aKey,@aDefine)

cKey := Alltrim(Upper(cKey))
cKey := Strtran(cKey,'-','_')
cKey := Strtran(cKey,' ','_')
cKey := Strtran(cKey,'xbeK_','')
cKey := Strtran(cKey,'CONTROL','CTRL')
cKey := Strtran(cKey,'SHIFT','SH')
cKey := 'xbeK_' + cKey

nFound := AScan( aDefine, cKey )

IF nFound > 0
  RETURN aKey[nFound]
ENDIF

RETURN 0

* -------------

FUNCTION Num2KeyString( nKey )

LOCAL cKey

cKey := DC_AppKeyDefine(nKey)
cKey := Strtran(cKey,'xbeK','')
cKey := Strtran(cKey,'_CTRL_','Ctrl-')
cKey := Strtran(cKey,'_SH_','Shift-')
cKey := Strtran(cKey,'_ALT_','Alt-')
cKey := Strtran(cKey,'_','')

RETURN cKey

* -------------

FUNCTION FlashTest()

LOCAL cBin := FlashWInfo()

FlashWindowEx( @cBin )

RETURN nil

* -------------

FUNCTION FlashWInfo( hWnd, nFlags, nCount, nTimeOut )

# define FLASHW_ALL        0x00000003 // Flash both the window caption and taskbar button.
                                      // This is equivalent to setting the FLASHW_CAPTION | FLASHW_TRAY flags.
# define FLASHW_CAPTION    0x00000001 // Flash the window caption.
# define FLASHW_STOP       0          // Stop flashing. The system restores the window to its original state.
# define FLASHW_TIMER      0x00000004 // Flash continuously, until the FLASHW_STOP flag is set.
# define FLASHW_TIMERNOFG  0x0000000C // Flash continuously until the window comes to the foreground.
# define FLASHW_TRAY       0x00000002 // Flash the Taskbar button

LOCAL aBin, cBin

DEFAULT hWnd := SetAppWindow():getHwnd(), ;
        nFlags := FLASHW_TRAY, ;
        nCount := 5, ;
        nTimeOut := 500

/*
typedef struct {
    UINT cbSize;
    HWND hwnd;
    DWORD dwFlags;
    UINT uCount;
    DWORD dwTimeout;
    } FLASHWINFO
*/

aBin := BaInit(5)

BaStruct( aBin, 20 )       // cbSize
BaStruct( aBin, hwnd )     // hwnd
BaStruct( aBin, nFlags )   // dwFlags
BaStruct( aBin, nCount )   // uCount
BaStruct( aBin, nTimeOut ) // dwTimeout

cBin := BaAccess(aBin)

RETURN cBin

* ---------------

DLLFUNCTION FlashWindowEx( cBin ) USING STDCALL FROM USER32.DLL

* ---------------

FUNCTION WinWhoAmi()

LOCAL cUsername := Space(100), nUserLen := 100

GetUserNameA(@cUserName,@nUserLen)
cUserName := Strtran(cUserName,Chr(0),'')

RETURN Alltrim(cUserName)

* ---------------

// This function returns a different file name with each call,

STATIC FUNCTION TempFileName( cPath, cExt )

LOCAL nSeconds := Seconds(), cFileName
STATIC snCount := 0

DEFAULT cExt := '.IM'

DO WHILE Seconds() - nSeconds < 100
  IF ++ snCount == 100
    snCount := 0
  ENDIF
  cFileName   := PadL( snCount, 2, "_" )    + ;
                 StrTran( Time(), ":", "" ) + ".$$$" + cExt
  IF !File(cPath+cFileName)
    EXIT
  ENDIF
ENDDO

RETURN cFileName

* ---------

#INCLUDE "xb2netkey.prg"
